#!/usr/bin/env python

### THIS LINE IN THE TOP
from dttcmd import *

###GLOBAL VAR
main_round = 68     # USE FOR ROUND FRONT STEM, 68=CLOSE TO FRONT,72=NORMAL
#thai_round = main_round + 1
thai_round = main_round + 1
ppem_allow_shoot = 32

### GENERATED CODE
func_arg_list = [[2, 0], [1, 0], [3, 1], [1, 1], [4, 0], [0, 1], [0, 1], [0, 1], [3, 0], [3, 0], [2, 0], [1, 0], [1, 0], [4, 0], [3, 0], [5, 0], [2, 0], [2, 0], [2, 0], [3, 0], [0, 0], [2, 2], [3, 0]]

cvt_dict = {
    'vbase_shoot_max' 	: 0,   #-27
    'vbase-shoot' 		: 1,   #-16
    'vheight' 			: 2,   #1117
    'vheight_shoot' 	: 3,   #1144
    'vheight_num'       : 4,   #1489
        'vheight_cap'       : 4,   #1489
    'vheight_b'         : 5,   #1556
    'vheight_po'        : 6,   #1649
    'vheight_lu'        : 7,   #-442
        'vheight_p'         : 7,   #-442
    'vheight_tnum'      : 8,   #924
    'cvt_9' : 9,   #0
    'cvt_10' : 10,   #0
    'cvt_11' : 11,   #0
    'cvt_12' : 12,   #0
    'estemt'            : 13,   #268
    'estemw'            : 14,   #350
    'estemw_num'        : 15,   #363
    'ecstemw'           : 16,   #374
        'estemwc_num'           : 16,   #374
    'ecstemwc'          : 17,   #386
    'ecstemt'           : 18,   #284
        'estemt_num'        : 18,   #284
    'ecstemtc'          : 19,   #274
        'estemtc_num'      : 19,   #274
    'estemwc'           : 20,   #375
    'estemtc'           : 21,   #252
    'estemtc_max'       : 22,   #272
    'tstemw'            : 23,   #291
        'tstemw_num'            : 23,   #291
    'tstemwc'           : 24,   #281
        'tstemwc_num'           : 24,   #281
    'tstemt'            : 25,   #240
        'tstemt_num'            : 25,   #240
    'tstemtc'           : 26,   #242
        'tstemtc_num'           : 26,   #242
    'headdia'           : 27,   #434
    'headstem'          : 28,   #131
    'headhole'          : 29,   #172
    'hsph'              : 30,   #318    #headstemplushole
    'tstemt_thin'       : 31,   #159
    'tstemt_mid'        : 32,   #211
        'estemt_a'        : 32,   #211
    'estemt_mid'        : 33,   #244
    'ecstemt_mid'       : 34,   #260
    }

#---GENERATE STEM FUNCTION---
#predefine delta string of stem (put before gen_cvt_func)
#ds_headstem = "9-4 30-4 31-4 32-4 33-4 34-4 "
#ds_headstemplushole = "9-4 30+4 31+4 32-4 33-4 34-4 "
#ds_headsara = "9-4 "
#
ds_tstemw = ds_tstemwc = "10+4 11+3 12+2 13+1 15-1 16-2 17+4 18+3 19+2 20+1 22-1 23-2 24-3 "
ds_tstemtc = ds_tstemt = "10-1 11-2 12-3 13-4 14-5 15-6 16-7 18-1 19-2 20-3 21-4 22-5 23-6 24-7 "
ds_tstemw_num = ds_tstemwc_num = ds_tstemw
ds_tstemt_num = ds_tstemtc_num = ds_tstemt_mid = ds_tstemt
ds_estemw = "10+2 11+1 12-1 13-2 14-4 15-5 16-6 18-1 19-2 20+4 21+3 22+2 24-1 "
ds_estemwc = "9-1 11-1 12-2 13-3 14-5 15-6 16-8 17-1 18-3 19-4 20+3 21+1 23-2 24-3 "
ds_ecstemw = "9-1 10+1 12-2 13-3 14-5 15-6 16-7 17-1 18-2 19-4 20+3 21+1 23-2 24-3 "
ds_ecstemwc = "9-2 11-1 12-2 13-4 14-6 15-7 16-8 17-2 18-3 19-5 20+1 22-1 23-3 24-5 "
ds_estemw_num = "9-1 10+2 12-1 13-3 14-4 15-5 16-7 18-2 19-3 20+2 21+1 23-1 24-2 "
ds_estemwc_num = "9-2 10+1 12-2 13-4 14-5 15-6 16-8 17-2 18-3 19-4 20+1 23-2 24-3 "
ds_tstemt_thin = "12-1 13-1 14-2 15-2 "
ds_estemt = "9-2 10-3 11-4 12-5 13-6 14-7 15-8 16-8 16-1 17-2 18-3 19-4 20-1 21-2 24-1 "
ds_estemtc = ds_estemtc_max = "9-1 10-2 11-3 12-4 13-5 14-6 15-7 16-8 17-1 18-2 19-2 20-3 21-4 22-5 "
ds_estemt_a = "9-1 10-1 11-1 12-2 13-3 14-4 15-5 16-5 17-2 18-3 19-4 20-1 21-2 22-2 23-3 24-4 "
ds_ecstemt = ds_ecstemtc = "9-2 10-3 11-4 12-6 13-6 14-7 15-8 16-8 16-1 17-3 18-4 19-5 20-2 21-3 22-4 23-2 24-3 "
ds_estemt_mid = ds_ecstemt_mid = "9-1 10-2 11-3 12-4 13-5 14-6 15-7 16-8 17-1 18-2 19-3 20+3 21+2 22+1 "
ds_estemt_num = ds_estemtc_num = "9-2 10-3 11-4 12-5 13-6 14-7 15-8 15-1 16-8 16-1 17-2 18-3 19-4 22-1 23-2 "

ds_headstem = "14-2 15-2 16-2 18-1 19-2 20-3 21-4 22-4 23-4 24-5 25-5 26-2 27-2 28-2 "
#
ds_hsph = "11-8 12-8 13-8 17-8 "
ds_headhole = "9-4 10-5 11-6 12-7 13-8 18+4 19+3 20+2 21+1 24+4 25+3 26+2 27+1 "

gen_cvt_func_dict = {
    #[min,black]
    #'mb':   ['estem*','tstem*','stem*'],
    'mb':   ['ecstem*','estem*','tstemw*','tstemt*','stem*','headdia','head_sara_stem','head_sara'],
    #[min,rnd,grey]
    #'mrg':  ['headdia','headstem*','head_sara_stem','head_sara'],
    #[min,white]
    'w':  ['headhole'],
    'rg': ['hsph'],
    'b' : ['headstem*'],
    }

for arg,cvt_list in gen_cvt_func_dict.iteritems():
    new_list = []
    for i in cvt_list:
        if i[-1]=='*': 
            c = i.strip('*')
            n = len(c)
            l = [x for x in cvt_dict.keys() if x[:n]==c]
            new_list.extend(l)
        else:
            new_list.append(i)

    for i in new_list:
#        for j in ['1','1m','2','2m']:   #1=forward/bottomup, #2=reverse/topdown
#            if j[-1] == 'm':    #m=move rp0
        for j in ['_1','0_1','_2','0_2']:   #1=forward/bottomup, #2=reverse/topdown
            if j[0] == '0':    #m=move rp0
                cmd = 'mirp0'+arg
            else:
                cmd = 'mirp'+arg
#            if j[0] == '1': #1=forward/bottomup, #2=reverse/topdown
            if j[-1] == '1': #1=forward/bottomup, #2=reverse/topdown
                direction = '+'
            else:
                direction = '-'
            #AUTO GENERATE delta string
            try:
                exec "a = ds_%s " % (i,)
            except:
                exec "ds_%s = ''" % (i,)
            #GEN FUNC
#            exec '''def %s_%s(s,direction="%s"):
#    return %s("%s",s,ds_%s,direction,)
#''' % (i,j,direction,cmd,i,i,)
            exec '''def %s%s(s,direction="%s"):
    return %s("%s",s,ds_%s,direction,)
''' % (i,j,direction,cmd,i,i,)

            #GEN EXTRA FUNC FOR THIN OF estemt, tstemt
            #USE IN UPPER STEM OF kho_khai, kho_kwai
            #***PREDEFINE: ds_estemt_thin
            if i in ['estemt','estemtc','tstemt','tstemtc']:
                #AUTO GENERATE delta string
                try:
                    exec "a = ds_%s_thin " % (i,)
                except:
                    exec "ds_%s_thin = ''" % (i,)
                #GEN FUNC
                exec '''def %s_thin_%s(s,direction="%s"):
    return %s("%s",s,ds_%s_thin,direction,)
''' % (i,j,direction,cmd,i,i,)



pseudo_fpgm = """
                           #--- PUSHB_1   0         ;PUSH Bytes
FDEF            0          ;Function DEFinition
                           #--- PUSHB_1   0         ;PUSH Bytes
SZP0            0          ;Set Zone Pointer 0
MPPEM                      ;Measure Pixels Per EM
                           #--- PUSHB_1   42        ;PUSH Bytes
LT              42 &_MPPEM_1 ; Less Than
IF              &_LT_1     ;   IF test
                           #--- PUSHB_1   74        ;PUSH Bytes
SROUND          74         ;Super ROUND
EIF                        ;    End IF
                           #--- PUSHB_1   0         ;PUSH Bytes
SWAP            0 &_arg_1  ;SWAP the top two elements on the stack
MIAP[rnd]       &_SWAP_1 &_SWAP_2 ;Move Indirect Absolute Point
RTG                        ;Round To Grid
                           #--- PUSHB_1   6         ;PUSH Bytes
CALL            6          ;CALL function
IF              &_f6_retval_1 ;   IF test
RTDG                       ;Round To Double Grid
EIF                        ;    End IF
MPPEM                      ;Measure Pixels Per EM
                           #--- PUSHB_1   42        ;PUSH Bytes
LT              42 &_MPPEM_1 ; Less Than
IF              &_LT_1     ;   IF test
RDTG                       ;Round Down To Grid
EIF                        ;    End IF
DUP             &_arg_2    ;DUPlicate top stack element
MDRP[rp0,rnd,grey] &_DUP_1    ;Move Direct Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SZP0            1          ;Set Zone Pointer 0
MDAP[no-rnd]    &_DUP_2    ;Move Direct Absolute Point
RTG                        ;Round To Grid
ENDF                       ;END Function definition
#ARG_COUNT=2:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   1         ;PUSH Bytes
FDEF            1          ;Function DEFinition
DUP             &_arg_1    ;DUPlicate top stack element
MDRP[rp0,min,white] &_DUP_1    ;Move Direct Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
CALL            12 &_DUP_2 ;CALL function
ENDF                       ;END Function definition
#ARG_COUNT=1:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   2         ;PUSH Bytes
FDEF            2          ;Function DEFinition
MPPEM                      ;Measure Pixels Per EM
GT              &_MPPEM_1 &_arg_1 ;Greater Than
IF              &_GT_1     ;   IF test
RCVT            &_arg_2    ;Read Control Value Table entry
SWAP            &_RCVT_1 &_arg_3 ;SWAP the top two elements on the stack
EIF                        ;    End IF
POP             &_SWAP_1   ;POP top stack element
ENDF                       ;END Function definition
#ARG_COUNT=3:
#RET_COUNT=1: &_SWAP_2
#------------------

                           #--- PUSHB_1   3         ;PUSH Bytes
FDEF            3          ;Function DEFinition
ROUND[Black]    &_arg_1    ;ROUND value
RTG                        ;Round To Grid
DUP             &_ROUND_1  ;DUPlicate top stack element
                           #--- PUSHB_1   64        ;PUSH Bytes
LT              64 &_DUP_1 ; Less Than
IF              &_LT_1     ;   IF test
POP             &_DUP_2    ;POP top stack element
                           #--- PUSHB_1   64        ;PUSH Bytes
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=1:
#RET_COUNT=1: 64
#------------------

                           #--- PUSHB_1   4         ;PUSH Bytes
FDEF            4          ;Function DEFinition
                           #--- PUSHB_1   6         ;PUSH Bytes
CALL            6          ;CALL function
IF              &_f6_retval_1 ;   IF test
POP             &_arg_1    ;POP top stack element
SWAP            &_arg_2 &_arg_3 ;SWAP the top two elements on the stack
POP             &_SWAP_1   ;POP top stack element
ROFF                       ; Round OFF
IF              &_SWAP_2   ;   IF test
MDRP[rp0,min,rnd,black] &_arg_4    ;Move Direct Relative Point
ELSE                       ;ELSE clause
MDRP[min,rnd,black] &_arg_4    ;Move Direct Relative Point
EIF                        ;    End IF
ELSE                       ;ELSE clause
MPPEM                      ;Measure Pixels Per EM
GT              &_MPPEM_1 &_arg_1 ;Greater Than
IF              &_GT_1     ;   IF test
IF              &_arg_2    ;   IF test
MIRP[rp0,min,rnd,black] &_arg_3 &_arg_4 ;Move Indirect Relative Point
ELSE                       ;ELSE clause
MIRP[min,rnd,black] &_arg_3 &_arg_4 ;Move Indirect Relative Point
EIF                        ;    End IF
ELSE                       ;ELSE clause
SWAP            &_arg_2 &_arg_3 ;SWAP the top two elements on the stack
POP             &_SWAP_1   ;POP top stack element
                           #--- PUSHB_1   5         ;PUSH Bytes
CALL            5          ;CALL function
IF              &_f5_retval_1 ;   IF test
                           #--- PUSHB_1   70        ;PUSH Bytes
SROUND          70         ;Super ROUND
EIF                        ;    End IF
IF              &_SWAP_2   ;   IF test
MDRP[rp0,min,rnd,black] &_arg_4    ;Move Direct Relative Point
ELSE                       ;ELSE clause
MDRP[min,rnd,black] &_arg_4    ;Move Direct Relative Point
EIF                        ;    End IF
EIF                        ;    End IF
EIF                        ;    End IF
RTG                        ;Round To Grid
ENDF                       ;END Function definition
#ARG_COUNT=4:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   5         ;PUSH Bytes
FDEF            5          ;Function DEFinition
GFV                        ;Get Freedom Vector
NOT             &_GFV_1    ;logical NOT
AND             &_NOT_1 &_GFV_2 ;logical AND
ENDF                       ;END Function definition
#ARG_COUNT=0:
#RET_COUNT=1: &_AND_1
#------------------

                           #--- PUSHB_1   6         ;PUSH Bytes
FDEF            6          ;Function DEFinition
                           #--- PUSHB_2   34 1      ;PUSH Bytes
GETINFO         1          ;GET INFOrmation
LT              &_GETINFO_1 34 ; Less Than
IF              &_LT_1     ;   IF test
                           #--- PUSHB_1   32        ;PUSH Bytes
GETINFO         32         ;GET INFOrmation
NOT             &_GETINFO_1 ;logical NOT
NOT             &_NOT_1    ;logical NOT
ELSE                       ;ELSE clause
                           #--- PUSHB_1   0         ;PUSH Bytes
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=0:
#RET_COUNT=1: &_NOT_1
#------------------

                           #--- PUSHB_1   7         ;PUSH Bytes
FDEF            7          ;Function DEFinition
                           #--- PUSHB_2   36 1      ;PUSH Bytes
GETINFO         1          ;GET INFOrmation
LT              &_GETINFO_1 36 ; Less Than
IF              &_LT_1     ;   IF test
                           #--- PUSHB_1   64        ;PUSH Bytes
GETINFO         64         ;GET INFOrmation
NOT             &_GETINFO_1 ;logical NOT
NOT             &_NOT_1    ;logical NOT
ELSE                       ;ELSE clause
                           #--- PUSHB_1   0         ;PUSH Bytes
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=0:
#RET_COUNT=1: &_NOT_1
#------------------

                           #--- PUSHB_1   8         ;PUSH Bytes
FDEF            8          ;Function DEFinition
SRP2            &_arg_1    ;Set Reference Point 2
SRP1            &_arg_2    ;Set Reference Point 1
DUP             &_arg_3    ;DUPlicate top stack element
IP              &_DUP_1    ;Interpolate Point
MDAP[rnd]       &_DUP_2    ;Move Direct Absolute Point
ENDF                       ;END Function definition
#ARG_COUNT=3:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   9         ;PUSH Bytes
FDEF            9          ;Function DEFinition
DUP             &_arg_1    ;DUPlicate top stack element
RDTG                       ;Round Down To Grid
                           #--- PUSHB_1   6         ;PUSH Bytes
CALL            6          ;CALL function
IF              &_f6_retval_1 ;   IF test
MDRP[rnd,grey]  &_DUP_1    ;Move Direct Relative Point
ELSE                       ;ELSE clause
MDRP[min,rnd,black] &_DUP_2    ;Move Direct Relative Point
EIF                        ;    End IF
DUP             &_DUP_2    ;DUPlicate top stack element
                           #--- PUSHB_1   3         ;PUSH Bytes
CINDEX          3          ;Copy the INDEXed element to the top of the stack
MD[grid]        &_CINDEX_1 &_DUP_1 ;Measure Distance
SWAP            &_MD_1 &_DUP_2 ;SWAP the top two elements on the stack
DUP             &_SWAP_1   ;DUPlicate top stack element
                           #--- PUSHB_1   4         ;PUSH Bytes
MINDEX          4          ;Move the INDEXed element to the top of the stack
MD[orig]        &_DUP_1 &_DUP_2 ;Measure Distance
                           #--- PUSHB_1   0         ;PUSH Bytes
LT              0 &_MD_1   ; Less Than
IF              &_LT_1     ;   IF test
ROLL            &_SWAP_2 &_arg_2 &_arg_3 ;ROLL the top three stack elements
NEG             &_ROLL_1   ;    NEGate
ROLL            &_NEG_1 &_ROLL_2 &_ROLL_3 ;ROLL the top three stack elements
SUB             &_ROLL_1 &_ROLL_2 ;  SUBtract
DUP             &_SUB_1    ;DUPlicate top stack element
                           #--- PUSHB_1   0         ;PUSH Bytes
LT              0 &_DUP_1  ; Less Than
IF              &_LT_1     ;   IF test
SHPIX           &_DUP_2 &_ROLL_3 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg_4    ;POP top stack element
POP             &_arg_5    ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
ROLL            &_arg_2 &_arg_3 &_arg_4 ;ROLL the top three stack elements
ROLL            &_ROLL_1 &_ROLL_2 &_ROLL_3 ;ROLL the top three stack elements
SUB             &_ROLL_1 &_ROLL_2 ;  SUBtract
DUP             &_SUB_1    ;DUPlicate top stack element
                           #--- PUSHB_1   0         ;PUSH Bytes
GT              0 &_DUP_1  ;Greater Than
IF              &_GT_1     ;   IF test
SHPIX           &_DUP_2 &_ROLL_3 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg_5    ;POP top stack element
POP             &_arg_6    ;POP top stack element
EIF                        ;    End IF
EIF                        ;    End IF
RTG                        ;Round To Grid
ENDF                       ;END Function definition
#ARG_COUNT=3:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   10        ;PUSH Bytes
FDEF            10         ;Function DEFinition
                           #--- PUSHB_1   6         ;PUSH Bytes
CALL            6          ;CALL function
IF              &_f6_retval_1 ;   IF test
POP             &_arg_1    ;POP top stack element
SRP0            &_arg_2    ;Set Reference Point 0
ELSE                       ;ELSE clause
SRP0            &_arg_1    ;Set Reference Point 0
POP             &_arg_2    ;POP top stack element
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=2:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   11        ;PUSH Bytes
FDEF            11         ;Function DEFinition
DUP             &_arg_1    ;DUPlicate top stack element
MDRP[rp0,white] &_DUP_1    ;Move Direct Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
CALL            12 &_DUP_2 ;CALL function
ENDF                       ;END Function definition
#ARG_COUNT=1:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   12        ;PUSH Bytes
FDEF            12         ;Function DEFinition
DUP             &_arg_1    ;DUPlicate top stack element
MDAP[rnd]       &_DUP_1    ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
CALL            7          ;CALL function
NOT             &_f7_retval_1 ;logical NOT
IF              &_NOT_1    ;   IF test
DUP             &_DUP_2    ;DUPlicate top stack element
DUP             &_DUP_1    ;DUPlicate top stack element
GC[orig]        &_DUP_1    ;Get Coordinate projected onto the projection vector
SWAP            &_GC_1 &_DUP_2 ;SWAP the top two elements on the stack
GC[cur]         &_SWAP_1   ;Get Coordinate projected onto the projection vector
SUB             &_GC_1 &_SWAP_2 ;  SUBtract
ROUND[White]    &_SUB_1    ;ROUND value
DUP             &_ROUND_1  ;DUPlicate top stack element
IF              &_DUP_1    ;   IF test
DUP             &_DUP_2    ;DUPlicate top stack element
ABS             &_DUP_1    ;ABSolute value
DIV             &_ABS_1 &_DUP_2 ;    DIVide
SHPIX           &_DIV_1 &_DUP_2 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg_2    ;POP top stack element
POP             &_arg_3    ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
POP             &_arg_2    ;POP top stack element
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=1:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   13        ;PUSH Bytes
FDEF            13         ;Function DEFinition
SRP2            &_arg_1    ;Set Reference Point 2
SRP1            &_arg_2    ;Set Reference Point 1
DUP             &_arg_3    ;DUPlicate top stack element
DUP             &_DUP_1    ;DUPlicate top stack element
IP              &_DUP_1    ;Interpolate Point
MDAP[rnd]       &_DUP_2    ;Move Direct Absolute Point
DUP             &_DUP_2    ;DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_arg_4 ;ROLL the top three stack elements
DUP             &_ROLL_1   ;DUPlicate top stack element
GC[orig]        &_DUP_1    ;Get Coordinate projected onto the projection vector
ROLL            &_GC_1 &_DUP_2 &_ROLL_2 ;ROLL the top three stack elements
GC[cur]         &_ROLL_1   ;Get Coordinate projected onto the projection vector
SUB             &_GC_1 &_ROLL_2 ;  SUBtract
SWAP            &_SUB_1 &_ROLL_3 ;SWAP the top two elements on the stack
ROLL            &_SWAP_1 &_SWAP_2 &_ROLL_3 ;ROLL the top three stack elements
DUP             &_ROLL_1   ;DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_ROLL_2 ;ROLL the top three stack elements
SWAP            &_ROLL_1 &_ROLL_2 ;SWAP the top two elements on the stack
MD[orig]        &_SWAP_1 &_SWAP_2 ;Measure Distance
                           #--- PUSHB_1   0         ;PUSH Bytes
LT              0 &_MD_1   ; Less Than
IF              &_LT_1     ;   IF test
SWAP            &_ROLL_3 &_ROLL_3 ;SWAP the top two elements on the stack
                           #--- PUSHB_1   0         ;PUSH Bytes
GT              0 &_SWAP_1 ;Greater Than
IF              &_GT_1     ;   IF test
                           #--- PUSHB_1   64        ;PUSH Bytes
SHPIX           64 &_SWAP_2 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg_5    ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
SWAP            &_arg_5 &_arg_6 ;SWAP the top two elements on the stack
                           #--- PUSHB_1   0         ;PUSH Bytes
LT              0 &_SWAP_1 ; Less Than
IF              &_LT_1     ;   IF test
                           #--- PUSHB_1   64        ;PUSH Bytes
NEG             64         ;    NEGate
SHPIX           &_NEG_1 &_SWAP_2 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg_7    ;POP top stack element
EIF                        ;    End IF
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=4:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   14        ;PUSH Bytes
FDEF            14         ;Function DEFinition
                           #--- PUSHB_1   6         ;PUSH Bytes
CALL            6          ;CALL function
IF              &_f6_retval_1 ;   IF test
RTDG                       ;Round To Double Grid
MDRP[rp0,rnd,white] &_arg_1    ;Move Direct Relative Point
RTG                        ;Round To Grid
POP             &_arg_2    ;POP top stack element
POP             &_arg_3    ;POP top stack element
ELSE                       ;ELSE clause
DUP             &_arg_1    ;DUPlicate top stack element
MDRP[rp0,rnd,white] &_DUP_1    ;Move Direct Relative Point
ROLL            &_DUP_2 &_arg_2 &_arg_3 ;ROLL the top three stack elements
MPPEM                      ;Measure Pixels Per EM
GT              &_MPPEM_1 &_ROLL_1 ;Greater Than
IF              &_GT_1     ;   IF test
DUP             &_ROLL_2   ;DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_ROLL_3 ;ROLL the top three stack elements
SWAP            &_ROLL_1 &_ROLL_2 ;SWAP the top two elements on the stack
MD[grid]        &_SWAP_1 &_SWAP_2 ;Measure Distance
DUP             &_MD_1     ;DUPlicate top stack element
                           #--- PUSHB_1   0         ;PUSH Bytes
NEQ             0 &_DUP_1  ; Not EQual
IF              &_NEQ_1    ;   IF test
SHPIX           &_DUP_2 &_ROLL_3 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg_4    ;POP top stack element
POP             &_arg_5    ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
POP             &_arg_4    ;POP top stack element
POP             &_arg_5    ;POP top stack element
EIF                        ;    End IF
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=3:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   15        ;PUSH Bytes
FDEF            15         ;Function DEFinition
SWAP            &_arg_1 &_arg_2 ;SWAP the top two elements on the stack
DUP             &_SWAP_1   ;DUPlicate top stack element
MDRP[rp0,rnd,white] &_DUP_1    ;Move Direct Relative Point
DUP             &_DUP_2    ;DUPlicate top stack element
MDAP[rnd]       &_DUP_1    ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
CALL            7          ;CALL function
NOT             &_f7_retval_1 ;logical NOT
IF              &_NOT_1    ;   IF test
SWAP            &_DUP_2 &_SWAP_2 ;SWAP the top two elements on the stack
DUP             &_SWAP_1   ;DUPlicate top stack element
IF              &_DUP_1    ;   IF test
MPPEM                      ;Measure Pixels Per EM
GTEQ            &_MPPEM_1 &_DUP_2 ;Greater Than or EQual
ELSE                       ;ELSE clause
POP             &_GTEQ_1   ;POP top stack element
                           #--- PUSHB_1   1         ;PUSH Bytes
EIF                        ;    End IF
IF              &_GTEQ_1   ;   IF test
ROLL            &_SWAP_2 &_arg_3 &_arg_4 ;ROLL the top three stack elements
                           #--- PUSHB_1   4         ;PUSH Bytes
MINDEX          4          ;Move the INDEXed element to the top of the stack
MD[grid]        &_ROLL_1 &_ROLL_2 ;Measure Distance
SWAP            &_MD_1 &_ROLL_3 ;SWAP the top two elements on the stack
ROLL            &_SWAP_1 &_SWAP_2 &_arg_5 ;ROLL the top three stack elements
SWAP            &_ROLL_1 &_ROLL_2 ;SWAP the top two elements on the stack
DUP             &_SWAP_1   ;DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_SWAP_2 ;ROLL the top three stack elements
MD[grid]        &_ROLL_1 &_ROLL_2 ;Measure Distance
ROLL            &_MD_1 &_ROLL_3 &_ROLL_3 ;ROLL the top three stack elements
SWAP            &_ROLL_1 &_ROLL_2 ;SWAP the top two elements on the stack
SUB             &_SWAP_1 &_SWAP_2 ;  SUBtract
SHPIX           &_SUB_1 &_ROLL_3 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg_3    ;POP top stack element
POP             &_arg_4    ;POP top stack element
POP             &_arg_5    ;POP top stack element
POP             &_arg_6    ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
POP             1          ;POP top stack element
POP             &_SWAP_2   ;POP top stack element
POP             &_arg_3    ;POP top stack element
POP             &_arg_4    ;POP top stack element
POP             &_arg_5    ;POP top stack element
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=5:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   16        ;PUSH Bytes
FDEF            16         ;Function DEFinition
DUP             &_arg_1    ;DUPlicate top stack element
MDRP[rp0,min,white] &_DUP_1    ;Move Direct Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
CALL            18 &_DUP_2 &_arg_2 ;CALL function
ENDF                       ;END Function definition
#ARG_COUNT=2:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   17        ;PUSH Bytes
FDEF            17         ;Function DEFinition
DUP             &_arg_1    ;DUPlicate top stack element
MDRP[rp0,white] &_DUP_1    ;Move Direct Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
CALL            18 &_DUP_2 &_arg_2 ;CALL function
ENDF                       ;END Function definition
#ARG_COUNT=2:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   18        ;PUSH Bytes
FDEF            18         ;Function DEFinition
DUP             &_arg_1    ;DUPlicate top stack element
MDAP[rnd]       &_DUP_1    ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
CALL            7          ;CALL function
NOT             &_f7_retval_1 ;logical NOT
IF              &_NOT_1    ;   IF test
DUP             &_DUP_2    ;DUPlicate top stack element
DUP             &_DUP_1    ;DUPlicate top stack element
GC[orig]        &_DUP_1    ;Get Coordinate projected onto the projection vector
SWAP            &_GC_1 &_DUP_2 ;SWAP the top two elements on the stack
GC[cur]         &_SWAP_1   ;Get Coordinate projected onto the projection vector
SUB             &_GC_1 &_SWAP_2 ;  SUBtract
ROUND[White]    &_SUB_1    ;ROUND value
ROLL            &_ROUND_1 &_DUP_2 &_arg_2 ;ROLL the top three stack elements
DUP             &_ROLL_1   ;DUPlicate top stack element
GC[orig]        &_DUP_1    ;Get Coordinate projected onto the projection vector
SWAP            &_GC_1 &_DUP_2 ;SWAP the top two elements on the stack
GC[cur]         &_SWAP_1   ;Get Coordinate projected onto the projection vector
SWAP            &_GC_1 &_SWAP_2 ;SWAP the top two elements on the stack
SUB             &_SWAP_1 &_SWAP_2 ;  SUBtract
ROUND[White]    &_SUB_1    ;ROUND value
ADD             &_ROUND_1 &_ROLL_2 ;       ADD
DUP             &_ADD_1    ;DUPlicate top stack element
IF              &_DUP_1    ;   IF test
DUP             &_DUP_2    ;DUPlicate top stack element
ABS             &_DUP_1    ;ABSolute value
DIV             &_ABS_1 &_DUP_2 ;    DIVide
SHPIX           &_DIV_1 &_ROLL_3 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg_3    ;POP top stack element
POP             &_arg_4    ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
POP             &_arg_2    ;POP top stack element
POP             &_arg_3    ;POP top stack element
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=2:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   19        ;PUSH Bytes
FDEF            19         ;Function DEFinition
DUP             &_arg_1    ;DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_arg_2 ;ROLL the top three stack elements
DUP             &_ROLL_1   ;DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_ROLL_2 ;ROLL the top three stack elements
SDPVTL[orthog]  &_ROLL_1 &_ROLL_2 ;Set Dual Projection Vector To Line
DUP             &_ROLL_3   ;DUPlicate top stack element
                           #--- PUSHB_1   3         ;PUSH Bytes
CINDEX          3          ;Copy the INDEXed element to the top of the stack
MD[orig]        &_CINDEX_1 &_DUP_1 ;Measure Distance
ABS             &_MD_1     ;ABSolute value
SWAP            &_ABS_1 &_DUP_2 ;SWAP the top two elements on the stack
ROLL            &_SWAP_1 &_SWAP_2 &_ROLL_3 ;ROLL the top three stack elements
SPVTL[orthog]   &_ROLL_1 &_ROLL_2 ;Set Projection Vector To Line
                           #--- PUSHB_1   32        ;PUSH Bytes
LT              32 &_ROLL_3 ; Less Than
IF              &_LT_1     ;   IF test
ALIGNRP         &_arg_3    ;ALIGN to Reference Point
ELSE                       ;ELSE clause
MDRP[grey]      &_arg_3    ;Move Direct Relative Point
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=3:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   20        ;PUSH Bytes
FDEF            20         ;Function DEFinition
                           #--- PUSHB_4   0 64 1 64 ;PUSH Bytes
WS              64 1       ;Write Store
WS              64 0       ;Write Store
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MPPEM                      ;Measure Pixels Per EM
                           #--- PUSHW_1   4096      ;PUSH Words
MUL             4096 &_MPPEM_1 ;  MULtiply
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MPPEM                      ;Measure Pixels Per EM
                           #--- PUSHW_1   4096      ;PUSH Words
MUL             4096 &_MPPEM_1 ;  MULtiply
DUP             &_MUL_1    ;DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_MUL_1 ;ROLL the top three stack elements
DUP             &_ROLL_1   ;DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_ROLL_2 ;ROLL the top three stack elements
NEQ             &_ROLL_1 &_ROLL_2 ; Not EQual
IF              &_NEQ_1    ;   IF test
DUP             &_ROLL_3   ;DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_ROLL_3 ;ROLL the top three stack elements
DUP             &_ROLL_1   ;DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_ROLL_2 ;ROLL the top three stack elements
GT              &_ROLL_1 &_ROLL_2 ;Greater Than
IF              &_GT_1     ;   IF test
SWAP            &_ROLL_3 &_ROLL_3 ;SWAP the top two elements on the stack
DIV             &_SWAP_1 &_SWAP_2 ;    DIVide
DUP             &_DIV_1    ;DUPlicate top stack element
                           #--- PUSHB_1   0         ;PUSH Bytes
SWAP            0 &_DUP_1  ;SWAP the top two elements on the stack
WS              &_SWAP_1 &_SWAP_2 ;Write Store
ELSE                       ;ELSE clause
DIV             &_DUP_2 &_arg_1 ;    DIVide
DUP             &_DIV_1    ;DUPlicate top stack element
                           #--- PUSHB_1   1         ;PUSH Bytes
SWAP            1 &_DUP_1  ;SWAP the top two elements on the stack
WS              &_SWAP_1 &_SWAP_2 ;Write Store
EIF                        ;    End IF
DUP             &_DUP_2    ;DUPlicate top stack element
                           #--- PUSHB_1   64        ;PUSH Bytes
GT              64 &_DUP_1 ;Greater Than
IF              &_GT_1     ;   IF test
                           #--- PUSHB_3   0 32 0    ;PUSH Bytes
RS              0          ;Read Store
MUL             &_RS_1 32  ;  MULtiply
WS              &_MUL_1 0  ;Write Store
                           #--- PUSHB_3   1 32 1    ;PUSH Bytes
RS              1          ;Read Store
MUL             &_RS_1 32  ;  MULtiply
WS              &_MUL_1 1  ;Write Store
                           #--- PUSHB_1   32        ;PUSH Bytes
MUL             32 &_DUP_2 ;  MULtiply
                           #--- PUSHB_1   25        ;PUSH Bytes
NEG             25         ;    NEGate
JMPR            &_NEG_1    ;JuMP Relative
POP             &_MUL_1    ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
POP             &_arg_1    ;POP top stack element
POP             &_arg_2    ;POP top stack element
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=0:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   21        ;PUSH Bytes
FDEF            21         ;Function DEFinition
                           #--- PUSHB_1   1         ;PUSH Bytes
RS              1          ;Read Store
MUL             &_RS_1 &_arg_1 ;  MULtiply
SWAP            &_MUL_1 &_arg_2 ;SWAP the top two elements on the stack
                           #--- PUSHB_1   0         ;PUSH Bytes
RS              0          ;Read Store
MUL             &_RS_1 &_SWAP_1 ;  MULtiply
SWAP            &_MUL_1 &_SWAP_2 ;SWAP the top two elements on the stack
ENDF                       ;END Function definition
#ARG_COUNT=2:
#RET_COUNT=2: &_SWAP_2 &_SWAP_1
#------------------
"""

### MANUAL FUNCTION
def v_dry_end(s):
    return f_dstr(s,"9-8 10-8 11-8 12-8 13-8 14-8 15-8 16-8 ")

def h_main_1(sx, s1,fx12,s2, r=68):
    s1,add1 = gen_alignrp(s1)
    s2,add2 = gen_alignrp(s2,a=2)
    if callable(fx12):
        x12 = fx12(s2)
    else:
        x12 = mdrpmb(s2,fx12)
    return pl(""
        , 'SROUND %s' % (r,)
        , ip_round(sx-1,sx,s1)
        , 'RTG'
        , add1
        , x12
        , add2
        )

def h_main_01(sx, s1, s2,fx23,s3, ds3x="", ds31="", r=68):
    s1,add1 = gen_alignrp(s1)
    s2,add2 = gen_alignrp(s2,a=2)
    s3,add3 = gen_alignrp(s3)
    sx,addx = gen_alignrp(sx)
    if callable(fx23):
        x23 = fx23(s2)
    else:
        x23 = mdrpmb(s2,fx23,direction='-')
    return pl(""
        , srp0(sx)
        , addx
        , mdrp0mrw(s3,ds3x)
        , add3
        , x23
        , add2
        , 'SROUND %s' % (r,)
        , ip_round(sx-1,s3,s1,ds31)
        , 'RTG'
        , add1
        )

def h_main_10(sx, s1,fx12,s2, s3, r=68, ds31=""):
    s1,add1 = gen_alignrp(s1)
    s2,add2 = gen_alignrp(s2,a=2)
    s3,add3 = gen_alignrp(s3)
    sx,addx = gen_alignrp(sx)
    if callable(fx12):
        x12 = fx12(s2)
    else:
        x12 = mdrpmb(s2,fx12)
    return pl(""
        , srp0(sx)
        , addx
        , mdrp0mrw(s3)
        , add3
        , 'SROUND %s' % (r,)
        , ip_round(sx-1,s3,s1,ds31)
        , 'RTG'
        , add1
        , x12
        , add2
        )

def ht_main_head(sx, s2,s3,s4, s5,s6, s7,s8):
    s3,add3 = gen_alignrp(s3,a=2)
    s4,add4 = gen_alignrp(s4,a=2)
    s5,add5 = gen_alignrp(s5)
    s6,add6 = gen_alignrp(s6,a=2)
    return pl(""
        , h_main_01(sx, s2, s7,tstemw_2,s8)
        , headstem_1(s3)
        , add3
        , hsph_1(s4)
        , add4
        , mdrp0rg(s5)
        , add5
        , tstemw_1(s6)
        , add6
        )

def h_skel_2(sx, s1,fx12,s2, s3,fx34,s4, ds41="", ds4x="", r=68):
    s1,add1 = gen_alignrp(s1)
    s2,add2 = gen_alignrp(s2,a=2)
    s3,add3 = gen_alignrp(s3,a=2)
    s4,add4 = gen_alignrp(s4)
    sx,addx = gen_alignrp(sx)
    s0 = sx-1
    if callable(fx12):
        x12 = fx12(s2)
    else:
        x12 = mdrpmb(s2,fx12)
    if callable(fx34):
        x34 = fx34(s3)
    else:
        x34 = mdrpmb(s3,fx34,direction="-")

    return pl(""
        , mdapr(sx)
        , addx
        , mdrp0mrw(s4,ds4x)
        , add4
        , x34
        , add3
#
        , mdrpg(s2)
        , 'SROUND %s' % (r,)
        , ip_round(s0,s2,s1,ds41)
        , 'RTG'
        , add1
        , x12
        , add2
        )

def h_int_2(sx, s1,fx12,s2, s3,fx34,s4, ds41="",ds4x="",r=70):
    return h_skel_2(sx, s1,fx12,s2, s3,fx34,s4, ds41,ds4x,r)

def h_main_2(sx, s1,fx12,s2, s3,fx34,s4, ds41="",ds4x="",r=68):
    return h_skel_2(sx, s1,fx12,s2, s3,fx34,s4, ds41, ds4x,r)

def h_lap_2(sx, s1,fx12,s2, s3,fx34,s4, ds41="", ds3x="", r=76):
    # input dstr instead of fx to use mdrp
    s1,add1 = gen_alignrp(s1)
    s2,add2 = gen_alignrp(s2,a=2)
    s3,add3 = gen_alignrp(s3)
    s4,add4 = gen_alignrp(s4,a=2)
    sx,addx = gen_alignrp(sx)
    s0 = sx-1
    if callable(fx12):
        x12 = fx12(s2)
    else:
        x12 = mdrpmb(s2,fx12)
    if callable(fx34):
        x34 = fx34(s4)
    else:
        x34 = mdrpmb(s4,fx34)
    return pl(""
        , mdapr(sx)
        , addx
        , 'SROUND %s' % (r,)
        , mdrp0mrw(s3,ds3x)
        , 'RTG'
        , add3
        , x34
        , add4
#
        , mdapr(s1)
        , add1
        , x12
        , add2
        )

def h_notch_ko(s1, s2,s3,s4,s5):
    return pl(""
#        , srp0(s1)
#        , 'SROUND 70'
#        , mdrp0rg(s2)
#        , 'RTG'
#        , tstemw_1(s3)
#        , srp0(s1)
#        , 'SROUND 74'
#        , mdrp0mrb(s4,"14+8 15+8 ")
#        , 'RTG'
#        , mdrpb(s5)
, srp0(s1)
, 'SROUND 70'
, mdrp0rg(s2)
, 'RTG'
, mdrpg(s5)
, f_ip([s3,s4])
, f_dstr(s3,ds_tstemw)
, f_dstr(s4,ds_tstemw,direction="-")
        )

    
def h_serif(s2):
    return pl(""
        , 'SROUND 69'
        , mdrprg(s2)
        , 'RTG'
        )

def h_skel_head(s2,s3,s4,fx2=headhole_2,fx4=headstem_1,ds3="13-8 ",dir3="+"):
    s2,add2 = gen_alignrp(s2,a=2)
    s3,add3 = gen_alignrp(s3)
    s4,add4 = gen_alignrp(s4,a=2)
    return pl(""
        , 'SROUND 73'
        , mdrp0rg(s3)
        , 'RTG'
        , mdapr(s3,ds3,dir3)
        , add3
        , fx2(s2)
        , add2
        , fx4(s4)
        , add4
        )


def h_head_1(s2,s3,s4,ds3="13-8 23-8 "):
    return h_skel_head(s2,s3,s4,headhole_2,headstem_1,ds3)

def h_head_1r(s2,s3,s4,ds3="13-8 23-8 "):
    return h_skel_head(s2,s3,s4,headstem_2,headhole_1,ds3,dir3="-")


def h_head_2(s2,s3,s4,ds2=""):
    s2,add2 = gen_alignrp(s2)
    s3,add3 = gen_alignrp(s3,a=2)
    s4,add4 = gen_alignrp(s4,a=2)
    return pl(""
        #, 'SROUND 72'
        , mdrp0rg(s2,ds2)
        #, 'RTG'
        , add2
        , headstem_1(s3)
        , add3
        , hsph_1(s4)
        , mdapr(s4)
        , add4
        )

def h_head_khuat(s0,s1,s2, s3,s4,s5, sx,s6,s7, sip):
    return pl(""
        , 'RDTG'
        , ip_round(s0,s1,s2)
        , 'RTG'
#        , mdrpmb(s3,"9-8 10-8 "+ds_headstem)
        , mdrp0mrg(s4,"10-8 12-8 13-8 17-8 ")
        , headhole_2(s3)
        , headstem_1(s5)
        , ip_round(s2,sx,s6)
        , tstemwc_1(s7)
        , add_ip(s2,s7,sip)
        )

def v_head_1(s2,s3,s4, fx=headstem_1,fx3=hsph0_1,dir3="+"):
    s2,add2 = gen_alignrp(s2,a=2)
    s3,add3 = gen_alignrp(s3)
    s4,add4 = gen_alignrp(s4,a=2)
    return pl(""
        , fx(s2)
        , add2
        , fx3(s3)
        , mdapr(s3)
        , add3
        , fx(s4)
        , add4
        )

def v_head_2(s2,s3,s4):
    return v_head_1(s2,s3,s4,fx=headstem_2,fx3=hsph0_2,dir3="-")

def v_head_khuat(s1, s2,s3, s4, s5,s6,s7):
    return pl(""
        , mdrp0mrb(s2)
        , mdapr(s2)
        , tstemt_thin_2(s3)
        , srp0(s1)
        , 'RDTG'
        , mdrp0rg(s4)
        , 'RTG'
        , mdapr(s4)
        , v_head_2(s5,s6,s7)
        )

def e0_vheight(s1):
    return mirp0rg("vheight",s1)

def e0_num(s1):
    return mirp0rg("vheight_num",s1)

def e0_cap(s1):
    return mirp0rg("vheight_cap",s1)

def t0_vheight(s1):
    return mirp0rg("vheight",s1)

def t0_vheight_num(s1):
    return mirp0rg("vheight_tnum",s1)

def v_top(cvt1,s1, sip, s2):
    if sip:
        add_sip = f_ip(sip)
    else:
        add_sip = ""
    s1,add1 = gen_alignrp(s1)
    s2,add2 = gen_alignrp(s2)
    if s1 == 0: #LET s1=0, NO REFERENCE POINT, USE ZONE0=0 AS REF.POINT
        add01 = pl('SZP0 0', miapr(cvt1,s1))
        add02 = pl('SZP0 1')
    else:       #HAS REFERENCE POINT
        add01 = mirp0rg(cvt1,s1)
        add02 = ""
    return pl(""
        , add01
        , add_sip
        , add1
        , 'MPPEM'
        , 'LT %s' % (ppem_allow_shoot)
        , 'IF'
        , 'ROFF'
        , 'EIF'
        , mdrp0rg(s2)
        , 'RTG'
        , add02
        , add2
        )

def v_ko(s1, sip, s2,s3):
    s3,add3 = gen_alignrp(s3,a=2)
    return pl(""
        , v_top('vheight',s1, sip, s2)
        , tstemt_2(s3)
        , add3
        )

def v_khai(s1, sip, s2,s3):
    s3,add3 = gen_alignrp(s3,a=2)
    return pl(""
        , v_top('vheight',s1, sip, s2)
        , tstemt_thin_2(s3)
        , add3
        )

def v_ngo(s1, sip, s2): #s1=0
    return v_top('vheight', s1, sip, s2)

def v_a(s1, sip, s2,s3):
    s3,add3 = gen_alignrp(s3,a=2)
    return pl(""
        , v_top('vheight',s1, sip, s2)
        , estemtc_2(s3)
        , add3
        )

def v_b(s1, sip, s2,s3):
    s3,add3 = gen_alignrp(s3,a=2)
    return pl(""
        , v_top('vheight',s1, sip, s2)
        , estemtc_max_2(s3)
        , add3
        )

def v_C(s1, sip, s2,s3):
    s3,add3 = gen_alignrp(s3,a=2)
    return pl(""
        , v_top('vheight_cap',s1, sip, s2)
        , ecstemtc_2(s3)
        , add3
        )

def v_0(s1, sip, s2,s3):
    s3,add3 = gen_alignrp(s3,a=2)
    return pl(""
        , v_top('vheight_cap',s1, sip, s2)
        , estemtc_num_2(s3)
        , add3
        )


def v_skel_top(cvt1,fx2,s2):
    s2,add2 = gen_alignrp(s2)
    return pl(""
        , 'SZP0 0'
        , miapr(cvt1,0)
        , fx2(s2)
        , 'SZP0 1'
        , add2
        )

def vt_num(s2): #s1=0
    return v_skel_top('vheight_tnum',mdrp0g,s2)

def v_sara(s2):
    return v_skel_top('vheight',mdrp0rw,s2)

def shift(n,s1):    #SHIFT POINT IN REAL DISTANCE NOT DEPEND ON PPEM
    return pl(""
        , 'MPPEM'           #CURRENT POINT PER EM
        , 'MUL %s' % (n,)   #NUMBER OF PIXEL TO SHIFT
        , 'PUSHB 32'        #=EmSize/64 =2048/64 =32
        , 'SWAP'
        , 'DIV '
        ,'SHPIX %s' % (s1,) #POINT TO SHIFT
        )

pseudo_code_dict = {
    'exclam':
        packline(""
        , h_main_1(9, 1,ecstemw_1,3)
        , mdrpg(5)
        , mdrpg(6)
        , srp0(3)
        , mdrpg(4)
        , mdrpg(7)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , mirprg('vheight_cap',7)
        , mdrp0rb(3)
        , mdrp0mrw(4)
        , iy()
        ),

    'quotedbl':
        packline(""
        , srp0(9)
        , mdrp0mrw(7)
#        , mdrp0mb(6,ds_estemw,direction="-")
#        , mdrp0mrw(3)
#        , mdapr(3)
#        , mdrp0mb(2,ds_estemw,direction="-")
, 'SROUND 71'
, mdrp0mrb(6,"11+8 ")
, mdrp0mrw(3)
, mdapr(3)
, mdrp0mrb(2,"11+8 ")
, 'RTG'
        , ix()
        #y
        , sy()
        , mdapr(7)
        , alignrp(3)
        , mdrprg(4)
        , shprp2(0)
        , iy()
        ),

    'numbersign':
        packline(""
#        , mdapr(21)
#        , mdrprg(11)
#        , f_ip([14,18])
#        , mdrp0rg(25)
#        , mdrprg(7)
#        , f_ip([5,1])
#        , srp0(1)
#        , mdrpg(0)
#        , srp0(5)
#        , mdrpg(4)
#        , srp0(14)
#        , mdrpg(15)
#        , srp0(18)
#        , mdrpg(19)
#        , add_ip(5,14,[6,9,10,13])
#        , add_ip(4,15,[3,31,30,16])
#        , add_ip(1,18,[2,28,29,17])
#        , add_ip(0,19,[27,24,23,20])
#        , ix()
#        #y
#        , sy()
#        , mdapr(0)
#        , alignrp(4)
#        , e0_cap(19)
#        , alignrp(15)
#        , f_ip([20,24])
#        , mdapr(20)
#        , alignrp(17)
#        , alignrp(13)
#        , mdrpmb(22)
#        , shprp2(29)
#        , shprp2(10)
#        , mdapr(24)
#        , alignrp(28)
#        , alignrp(31)
#        , mdrpmb(27)
#        , shprp2(2)
#        , shprp2(9)
#        , iy()
, mdapr(33)
, mdrp0mrw(21)
, mdrprg(11,"10+8 ")
, f_ip([14,18])
, ip_round(32,21,7)
, mdrprg(26,"10-8 ")
, f_ip([5,1])
, srp0(14)
, mdrpmb(15,ds_estemt_a)
, srp0(18)
, mdrpmb(19,ds_estemt_a)
, srp0(5)
, mdrpmb(4,ds_estemt_a)
, srp0(1)
, mdrpmb(0,ds_estemt_a)
#y
, sy()
, mdapr(0)
, alignrp(4)
, mdrp0rg(19)
, alignrp(15)
, f_ip([21,25])
, mdapr(21)
, mdrpmb(22,ds_estemt_a,direction='-')
, f_ip([13,16,10,30])
, mdapr(25)
, mdrpmb(26,ds_estemt_a,direction='-')
, f_ip([9,31,3,6])
, iy()
, sx()
, fd_mdrp(5,14,5,[6,9,10,13])
, fd_mdrp(4,15,4,[3,31,30,16])
, fd_mdrp(1,18,1,[2,28,29,17])
, fd_mdrp(0,19,0,[27,24,23,20])
, ix()
        ),

    'dollar':
        packline(""
        , h_main_2(49, (13,5),estemw_1,45, 37,estemw_2,30)
        , srp0(30)
        , mdrprg(23)
        , ip_round(45,37,1)
        , alignrp(10)
        , alignrp(42)
        , alignrp(17)
        , mdrpg(33)
        , shprp2(40)
        , shprp2(26)
        , shprp2(18)
        , ix()
        #y
        , sy()
        , mdapr(2)
        , alignrp(33)
        , estemt_1(9)
        , shprp2(34)
        , mdrprg(0)
        , mdapr(19)
        , alignrp(16)
        , estemt_2(26)
        , shprp2(42)
        , mdrprg(18)
        , add_ip(26,9,[41])
        , srp0(41)
        , estemwc_2(40)
        , f_ip([27,10])
        , iy()
        ),

    'percent':
        packline(""
        , h_int_2(53, 31,tstemwc_1,49, 19,tstemwc_2,13)
        , mdrp0rg(43)
        , f_ip([1])
        , tstemwc_1(37)
        , srp0(13)
        , mdrp0rg(25)
        , f_ip([3])
        , tstemwc_2(7)
        , mdapr(1)
        , mdrpmb(0,ds_estemt_a)
        , mdapr(3)
        , mdrpmb(2,ds_estemt_a,direction="-")
        , ix()
        #y
        , sy()
        , mdapr(4)
        , alignrp(0)
        , estemt_a_1(16)
        , mdrp0rg(10)
        , estemt_a_2(22)
        , mdapr(34)
        , alignrp(3)
        , estemt_a_2(46)
        , mdrp0rg(28)
        , estemt_a_1(40)
        , iy()
        ),

    'ampersand':
        packline(""
        , h_main_2(55, 8,ecstemw_1,39, 27,ecstemw_2,28)
        , mdrp0rg(14)
        , ecstemw_1(51)
        , mdrp0rg(45)
        , ecstemw_1(20)
        , add_ip(14,20,[11,42,23,36])
        , srp0(27)
        , mdrpg(1)
        , srp0(28)
        , mdrpg(0)
        , add_ip(23,0,[35,24,31,2])
        , f_dstr(23,mul_dstr(ds_ecstemw,0.5))
        , f_dstr(11,mul_dstr(ds_ecstemw,0.5),direction="-")
        , f_dstr(31,mul_dstr(ds_ecstemw,0.5))
        , f_dstr(35,mul_dstr(ds_ecstemw,0.5),direction="-")
        , ix()
        #y
        , sy()
        , mdapr(0)
        , v_top('vheight_cap',0, [27,11,42,23,36,35,24,31,2], 17)
        , estemt_a_2(48)
        , srp0(0)
        , mdrp0g(5)
        , ecstemt_mid_1(32)
        , mdapr(27)
        , f_dstr(42,mul_dstr(ds_ecstemw,0.5))
        , f_dstr(36,mul_dstr(ds_ecstemw,0.5),direction="-")
        , f_dstr(24,mul_dstr(ds_ecstemw,0.5))
        , f_dstr(2,mul_dstr(ds_ecstemw,0.5),direction="-")
        , iy()
        ),

    'quotesingle':
        packline(""
#        , h_main_1(5,2,'',3)
, mdapr(5)
, mdrp0mrw(3)
, 'SROUND 71'
, mdrp0mrb(2,"11+8 ")
, 'RTG'
        , ix()
        #y
        , sy()
        , mdapr(3)
        , mdrprg(0)
        , iy()
        ),

    'parenleft':
        packline(""
        , h_main_2(16, 4,ds_estemw,11, (7,1),ds_estemw,(8,0))
        , ix()
        #y
        , sy()
        , mdapr(0)
        , mdapr(8)
        , iy()
        ),

    'parenright':
        packline(""
        , h_main_2(15, (1,7),ds_estemw,(0,8), 5,ds_estemw,10)  
        , ix()
        #y
        , sy() 
        , mdapr(0)
        , mdapr(8)
        , iy()
        ),

    'asterisk':
        packline(""
        , ip_round(18,19,1)
        , alignrp(9)
        , mdrpg(3)
        , shprp2(7)
        , mdrpg(4)
        , shprp2(6)
        , mdrpg(5)
        , mdrp0mb(0)
        , alignrp(10)
        , mdrpg(16)
        , shprp2(12)
        , mdrpg(15)
        , shprp2(13)
        , mdrpg(14)
        , ix()
        #y
        , sy()
        , mdapr(10)
        , mdrprg(0)
        , f_ip([2,3,4,5,6,7,8,11,12,13,14,15,16,17])
        , iy()
        ),

    'plus':
        packline(""
        , h_main_1(13, (1,5),estemt_1,(11,7), r=72)
        , 'SROUND 71'
        , mdrprg(3)
        , srp0(11)
        , mdrprg(9)
        , 'RTG'
        , ix()
        #y
        , sy()
        , 'SROUND 74'
        , mdapr(8)
        , alignrp(5)
        , 'SROUND 71'
        , mdrprg(7)
        , 'RTG'
        , estemt0_2(11)
        , shprp2(2)
        , 'SROUND 71'
        , mdrprg(0)
        , 'RTG'
        , iy()
        ),

    'comma':
        packline(""
        , mdapr(2)
        , ecstemw_1(3)
        , ix()
        #y
        , sy()
        , mdapr(3)
        , mdrprg(0)
        , iy()
        ),

    'hyphen':
        packline(""
        , srp0(5)
        , mdrp0mrw(0)
        , 'SROUND 70'
        , ip_round(4,0,1)
        , 'RTG'
        , ix()
        #y
        , sy()
        , 'SROUND 74'
        , mdapr(3)
        , ecstemtc_2(0)
        , iy()
        ),

    'period':
        packline(""
        , h_main_1(5, 1,estemw_1,3)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , estemwc_1(3)
        , iy()
        ),

    'slash':
        packline(""
        , mdapr(5)
        , mdrp0mrw(3)
        , 'SROUND 2'
        , mdrpmrb(2)
        , mdrp0rg(1)
        , mdrpmrb(0)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , mdapr(3)
        , iy()
        ),

    'colon':
        packline(""
        , h_main_1(9, (1,5),estemw_1,(3,7))
        , ix()
        #y
        , sy()
        , mdapr(0)
        , estemwc_1(3)
        , mdapr(4)
        , estemwc_1(7)
        , iy()
        ),

    'semicolon':
        packline(""
        , h_main_1(9, 5,estemw_1,7)
        , mdrp0g(2)
        , ecstemw_1(3)
        , ix()
        #y
        , sy()
        , mdapr(3)
        , mdrprg(0)
        , mdapr(4)
        , estemwc_1(7)
        , iy()
        ),

    'less':
        packline(""
        , h_main_10(8, 1,mul_dstr(ds_ecstemtc,1.7),5, (0,4))
        , ix()
        #y
        , sy()
        , mdapr(0)
        , ecstemtc_1(6)
        , mdapr(3)
        , ecstemtc_2(4)
        , add_ip(4,6,[5])
        , srp0(5)
        , mdrpg(1)
        , mdrpg(2)
        , iy()
        ),

    'greater':
        packline(""
        , h_main_01(8, (0,3), 2,mul_dstr(ds_ecstemtc,1.7),5)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , ecstemtc_1(1)
        , mdapr(4)
        , ecstemtc_2(3)
        , add_ip(3,1,[2])
        , srp0(2)
        , mdrpg(5)
        , mdrpg(6)
        , iy()
        ),

    'equal':
        packline(""
        , srp0(9)
        , mdrp0mrw(0)
        , alignrp(4)
        , mdrprg(2)
        , shprp2(6)
        , ix()
        #y
        , sy()
        , mdapr(3)
        , estemtc_2(0)
        , mdrp0rg(7)
        , estemtc_2(4)
        , iy()
        ),

    'question':
        packline(""
        , h_main_01(31, 17, 11,estemwc_2,24)
        , ip_round(17,24,5)
        , estemw_1(29)
        , mdrp0rg(1)
        , ecstemwc_1(3)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , v_top('vheight_cap',0, [8,9,26,27], 21)
        , estemtc_2(14)
        , srp0(0)
        , mdrp0rg(3)
        , mdrpmrw(4)
        , iy()
        , v_dry_end(18)
        ),

    'at':
        packline(""
        , h_main_2(57, 3,estemt_a_1,35, 29,estemt_a_2,9)
        , ip_round(3,9,18)
        , mdrpmrb(53)
        , ip_round(53,29,12)
        , alignrp(47)
        , alignrp(23)
        , mdrpmrb(25)
        , srp0(9)
        , mdrpg(42)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , estemt_a_1(38)
        , mdrp0rg(12)
        , estemt_a_1(27)
        , mdrp0g(15)
        , estemt_a_1(45)
        , mdapr(6)
        , estemt_a_2(32)
        , mdrp0rg(24)
        , mdrp0g(21)
        , estemt_a_2(50)
        , iy()
        ),

    'zero':
        packline(""
        , h_main_2(25, 3,estemwc_num_1,21, 15,estemwc_num_2,9)
        , ix()
        #y
        , sy()
        , mdapr(24)
        , mdrpg(0)
        , v_0(0,[],6,18)
        , srp0(0)
        , estemtc_num_1(12)
        , iy()
        ),

    'one':
        packline(""
        , 'SROUND 70'
        , ip_round(11,12,3)
        , alignrp(7)
        , 'RTG'
        , mdrprg(1)
        , mdrprg(5)
        , estemw_num0_1(8)
        , mdrprg(0)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , ecstemt_mid_1(10)
        , shprp2(3)
        , e0_num(8)
        , ecstemt_mid_2(4)
        , iy()
        ),

    'two':
        packline(""
        , h_main_2(23, 2,ds_estemw_num,21, 5,estemwc_num_2,18)
        , mdrprg(11)
        , srp0(18)
        , ip_round(18,23,22)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , estemt_num0_1(22)
        , mdrpg(2)
        , srp0(0)
        , v_0(0,[],15,8)
        , iy()
        , v_dry_end(12)
        ),

    'three':
        packline(""
        , h_main_01(43, 3, 10,estemwc_num_2,39)
        , mdrprg(25)
        , srp0(39)
        , mdrp0rg(33)
        , estemwc_num_2(19)
        , ip_round(3,39,14)
        , ix()
        #y
        , sy()
        , mdapr(42)
        , v_0(0,[],29,22)
        , srp0(42)
        , mdrp0g(0)
        , tstemtc_1(7)
        , ip_round(29,0,15)
        , estemt_num_2(14)
        , f_ip([36])
        , iy()
        ),

    'four':
        packline(""
        , h_main_2(15, 3,ds_estemw_num,13, (1,11),estemw_2,(10,6))
        , srp0(11)
        , mdrpg(5)
        , ip_round(10,15,9)
        , ix()
        #y  
        , sy()
        , mdapr(0)
        , e0_num(6)
        , mdrprg(12,ds_estemt_num,direction='-')
        , ip_round(12,0,7)
        , alignrp(11)
        , estemt_num_2(10)
        , shprp2(2)
        , mdrpg(4)
        , iy()
        ),

    'five':
        packline(""
        , h_main_2(31, 16,estemw_1,20, 10,estemwc_2,27)
        , mdrprg(4)
        , srp0(27)
        , mdrprg(19)
        , ix()
        #y  
        , sy()
        , mdapr(30)
        , mdrpg(0)
        , e0_num(18)
        , estemt_num_2(19)
        , srp0(0)
        , estemtc_num_1(7)
        , ip_round(18,0,24)
        , estemtc_num_2(13)
        , iy()
        ),

    'six':
        packline(""
        , h_main_2(38, 3,estemwc_1,(16,34), 28,estemwc_2,22)
        , srp0(22)
        , mdrprg(10)
        , ix()
        #y  
        , sy()
        , mdapr(38)
        , v_0(0,[19],6,13)
        , srp0(38)
        , mdrp0g(0)
        , estemtc_num_1(25)
        , mdapr(19)
        , estemtc_num_2(31)
        , iy()
        ),

    'seven':
        packline(""
        , h_main_01(8, 3, 2,estemwc_num_2,6)
        , add_ip(3,6,[1])
        , srp0(1)
        , mdrp0g(0,ds_estemwc_num)
        , ix()
        #y  
        , sy()
        , mdapr(0)
        , e0_num(5)
        , estemt_num_2(2)
        , shprp2(6)
        , iy()
        ),

    'eight':
        packline(""
        , h_main_2(49, 3,estemwc_num_1,33, 27,estemwc_num_2,21)
        , mdrp0g(9)
        , tstemwc_num_1(45)
        , srp0(21)
        , mdrp0g(15)
        , tstemwc_num_2(39)
        , add_ip(3,22,[6,30,36,18])
        , ix()
        #y  
        , sy()
        , mdapr(48)
        , v_0(0,[30,36],12,42)
        , srp0(48)
        , mdrp0g(0)
        , estemtc_num_1(24)
        , f_dstr(36,mul_dstr(ds_estemtc_num,0.5))
        , f_dstr(30,mul_dstr(ds_estemtc_num,0.5),direction='-')
        , add_ip(30,36,[6,18])
        , iy()
        ),

    'nine':
        packline(""
        , h_main_2(38, 16,estemwc_num_1,34, (28,10),estemwc_num_2,22)
        , srp0(16)
        , mdrprg(4)
        , ix()
        #y  
        , sy()
        , mdapr(38)
        , v_0(0,[25],19,31)
        , srp0(38)
        , mdrp0g(0)
        , estemtc_1(7)
        , mdapr(25)
        , estemtc_num_2(13)
        , iy()
        ),

    'A':
        packline(""
, h_lap_2(12, 5,estemwc_1,4, 1,estemwc_1,0)
#        , add_ip(4,1,[9,3,10,8,2])
, add_ip(4,1,[9])
        , srp0(9)
        , mdrpg(6)
        , mdrpg(7)
        #y
        , sy()
        , mdapr(1)
        , alignrp(4)
        , e0_cap(7)
        , f_ip([8])
        , mdrpg(9,mul_dstr(ds_estemwc,2.955),direction="-")
        , mdapr(8)
        , ecstemt_mid_2(2)
        , iy()
, sx()
, fd_mdrp(9,4,9,[10,3])
, fd_mdrp(9,1,9,[8,2])
, ix()
        ),

    'B':      
        packline(""
        , h_main_2(34, 1,ecstemw_1,(22,31), 18,ecstemwc_2,12)
        , srp0(12)
        , mdrp0rg(6)
        , ecstemwc_2(27)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , ecstemt_1(15)
        , e0_cap(3)
        , f_ip([24])
        , ecstemt_2(30)
        , mdapr(24,"12-8 13-8 ")
        , ecstemt_mid_2(21)
        , f_ip([9])
        , iy()
        ),

    'C':      
        packline(""
        , h_main_10(27, 3,ecstemwc_1,16, (23,10))
        , ix()
        #y
        , sy()
        , mdapr(26)
        , mdrpg(0)
        , v_C(0,[],6,13)
        , srp0(0)
        , ecstemtc_1(19)
        , iy()
        ),

    'D':      
        packline(""
        , h_main_2(19, 1,ecstemw_1,16, 12,ecstemwc_2,6)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , ecstemt_1(9)
        , e0_cap(3)
        , ecstemt_2(15)
        , iy()
        ),

    'E':      
        packline(""
        , h_main_10(13, 1,ecstemw_1,(9,5), 11)
        , srp0(11)
        , mdrpg(7)
        , mdrpg(3)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , ecstemt_1(11)
        , e0_cap(3)
        , f_ip([7])
        , ecstemt_2(4)
        , mdapr(7)
        , ecstemt_2(8)
        , iy()
        ),

    'F':      
        packline(""
        , h_main_10(11, 1,ecstemw_1,(9,5), 3)
        , srp0(3)
        , mdrpg(7)
#        , srp0(11)
#        , mdrp0mrw(4)
#        , mdrpg(8)
#        , 'SROUND 70'
#        , ip_round(10,4,1)
#        , 'RTG'
#        , ecstemw_1(9)
#        , shprp2(5)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , e0_cap(3)
        , f_ip([7])
        , ecstemt_2(4)
        , mdapr(7)
        , ecstemt_2(8)
        , iy()
        ),

    'G':      
        packline(""
        , h_main_2(31, 3,ecstemwc_1,16, 22,ecstemw_2,26)
        , srp0(26)
        , mdrprg(10)
        , ip_round(16,22,24)
        , ix()
        #y
        , sy()
        , mdapr(30)
        , mdrpg(0)
        , v_C(0,[25],6,13)
        , srp0(0)
        , ecstemtc_1(19)
        , mdapr(25)
        , ecstemt_mid_2(24)
        , iy()
        ),

    'H':      
        packline(""
        , h_main_2(13, 5,ecstemw_1,(3,7), (1,9),ecstemw_2,11)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , alignrp(4)
        , e0_cap(11)
        , shprp2(7)
        , f_ip([9])
        , mdapr(9)
        , ecstemt_2(2)
        , iy()
        ),

    'I':      
        packline(""
        , 'SROUND 70'
        , ip_round(12,13,3)
        , 'RTG'
        , ecstemw_1(9)
        , mdrprg(1)
        , shprp2(5)
        , srp0(9)
        , mdrprg(0)
        , shprp2(8)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , ecstemt_mid_1(11)
        , shprp2(3)
        , e0_cap(7)
        , ecstemt_mid_2(8)
        , shprp2(4)
        , iy()
        ),

    'J':      
        packline(""
, h_main_01(19, 3, 10,ecstemw_2,14)
#        , srp0(19)
#        , mdrp0mrw(14)
#        , ecstemw_2(10)
#        , mdrprg(12)
        , ip_round(18,14,12)
        , ix()
        #y
        , sy()
        , mdapr(18)
        , mdrpg(0)
        , e0_cap(14)
        , ecstemt_mid_2(11)
        , srp0(0)
        , ecstemtc_1(7)
        , iy()
        ),

    'K':      
        packline(""
        , h_lap_2(13, 5,ecstemw_1,(3,7), 1,ds_ecstemw,0)
        , srp0(1)
        , mdrpg(9)
        , srp0(0)
        , mdrpg(10)
        #y
        , sy()
        , mdapr(0)
        , alignrp(4)
        , e0_cap(10)
        , alignrp(7)
        , f_ip([8,3,2,11])
        , f_dstr(2,mul_dstr(ds_ecstemw,1.54),direction="-")
        , f_dstr(8,mul_dstr(ds_ecstemw,1.28))
        , iy()
, sx()
, fd_mdrp(10,3,10,[2,11])
, ix()
        ),

    'L':      
        packline(""
        , h_main_10(7, 1,ecstemw_1,3, 0)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , ecstemt_1(5)
        , e0_cap(3)
        , iy()
        ),


    'M':      
        packline(""
        , h_main_2(14, 7,ecstemw_1,5, 1,ecstemw_2,12)
        , add_ip(5,1,[10])
        , srp0(5)
        , mdrpg(9)
        , srp0(1)
        , mdrpg(11)
        , srp0(10)
        , mdrpg(4)
        , mdrpg(3)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , alignrp(6)
        , e0_cap(12)
        , f_ip([3])
        , alignrp(9)
#        , mdrpg(2,mul_dstr(ds_tstemt,1),direction='-')
#        , shprp2(5)
        , mdapr(3)
        , mdrpg(10,mul_dstr(ds_tstemw,2.29))
        , iy()
, fd_mdrp(10,9,4,[5])
, fd_mdrp(10,11,3,[2])
, f_dstr(5,ds_tstemt,direction='-')
, f_dstr(2,ds_tstemt,direction='-')
        ),

    'N':      
        packline(""
        , h_main_2(11, 4,ecstemw_1,2, 7,ecstemw_2,9)
        , srp0(2)
        , mdrpg(6)
        , srp0(7)
        , mdrpg(1)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , alignrp(3)
        , mdrpg(7,mul_dstr(ds_ecstemw,1.87))
        , e0_cap(9)
        , alignrp(6)
        , mdrpg(2,mul_dstr(ds_ecstemw,1.87),direction="-")
        , iy()
        ),

    'O':      
        packline(""
        , h_main_2(25, 3,ecstemwc_1,21, 15,ecstemwc_2,9)
        , ix()
        #y
        , sy()
        , mdapr(24)
        , mdrpg(0)
        , v_C(0,[],6,18)
        , srp0(0)
        , ecstemtc_1(12)
        , iy()
        ),

    'P':      
        packline(""
        , h_main_2(21, 1,ecstemw_1,(10,18), 14,ecstemwc_2,6)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , e0_cap(3)
        , f_ip([11])
        , ecstemt_2(17)
        , mdapr(11)
        , estemt_2(9)
        , iy()
        ),

    'Q':      
        packline(""
        , h_main_2(38, 3,ecstemwc_1,34, 28,ecstemwc_2,9)
        , ip_round(34,28,0)
        , ecstemw_1(12)
        , srp0(9)
        , mdrprg(18)
        , ix()
        #y
        , sy()
        , mdapr(37)
        , v_C(0,[],6,31)
        , srp0(37)
        , mdrprg(22)
        , mdrp0g(0)
        , ecstemtc_1(25)
        , f_ip([12])
        , srp0(22)
        , ecstemtc_1(15)
        , iy()
        ),

    'R':      
        packline(""
        , h_main_2(24, 5,ecstemw_1,(3,21), 17,ecstemwc_2,10)
        , add_ip(3,17,[2])
        , srp0(2)
        , ecstemwc_1(13)
        , srp0(10)
        , mdrpg(0)
        , srp0(17)
        , mdrpg(1)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , alignrp(4)
        , e0_cap(7)
        , f_ip([14])
        , ecstemt_2(20)
        , mdapr(14)
        , ecstemt_2(2)
        , f_ip([13])
        , iy()
        ),

    'S':      
        packline(""
        , h_main_2(37, 15,ecstemwc_1,28, 10,ecstemwc_2,33)
        , mdrprg(3)
        , srp0(33)
        , mdrprg(22)
        , add_ip(28,10,[12,13,30,31])
        , ix()
        #y
        , sy()
        , mdapr(36)
        , v_C(0,[31],18,25)
        , srp0(36)
        , mdrp0g(0)
        , ecstemtc_1(7)
        , srp0(31)
        , ecstemtc_2(13)
        , iy()
        ),

    'T':      
        packline(""
        , mdapr(3)
        , mdapr(5)
        , ip_round(3,5,1,"16+8 ")
        , mdrprg(3)
        , ecstemw0_1(7)
        , mdrprg(5)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , e0_cap(5)
        , ecstemt_2(6)
        , shprp2(2)
        , iy()
        ),

    'U':      
        packline(""
        , h_main_2(19, 3,ecstemw_1,5, 12,ecstemw_2,14)
        , ix()
        #y
        , sy()
        , mdapr(18)
        , mdrpg(0)
        , e0_cap(14)
        , shprp2(5)
        , srp0(0)
        , ecstemtc_1(9)
        , iy()
        ),

    'V':      
        packline(""
        , h_lap_2(8, 2,ecstemwc_1,3, 5,ecstemwc_1,6)
        , add_ip(3,5,[4])
        , srp0(4)
        , mdrpg(1)
        , mdrpg(0)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , mdrpg(4,mul_dstr(ds_ecstemwc,3.06))
        , e0_cap(6)
        , shprp2(3)
        , iy()
        ),

    'W':      
        packline(""
        , h_lap_2(14, 5,ecstemwc_1,6, 11,ecstemwc_1,12)
        , add_ip(6,11,[7,2,10])
        , srp0(7)
        , mdrpg(4)
        , mdrpg(3)
        , srp0(2)
        , mdrpg(8)
        , mdrpg(9)
        , srp0(10)
        , mdrpg(1)
        , mdrpg(0)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , alignrp(3)
        , mdrpg(10,mul_dstr(ds_ecstemwc,2.75))
        , shprp2(7)
        , e0_cap(12)
        , shprp2(9)
        , shprp2(6)
        , mdrpg(2,ds_ecstemwc,direction="-")
        , iy()
        ),

    'X':      
        packline(""
        , h_lap_2(13, 6,ds_ecstemwc,7, 9,ds_ecstemwc,10)
        , srp0(6)
        , mdrpg(4)
        , srp0(7)
        , mdrpg(3)
        , srp0(9)
        , mdrpg(1)
        , srp0(10)
        , mdrpg(0)
        , add_ip(7,9,[2,5,8,11])
        , f_dstr(11,mul_dstr(ds_ecstemwc,1))
        , f_dstr(5,mul_dstr(ds_ecstemwc,1),direction="-")
        , ix()
        #y
        , sy()
        , mdapr(0)
        , alignrp(3)
        , e0_cap(10)
        , f_ip([2,5,8,11])
        , alignrp(7)
        , f_dstr(8,mul_dstr(ds_ecstemwc,1))
        , f_dstr(2,mul_dstr(ds_ecstemwc,1),direction="-")
        , iy()
        ),

    'Y':      
        packline(""
        , h_lap_2(10, 3,estemwc_1,4, 6,estemwc_1,7)
        , ip_round(4,6,2)
        , ecstemw_1(8)
        , f_ip([5])
        , ix()
        #y
        , sy()
        , mdapr(0)
        , e0_cap(7)
        , alignrp(4)
        , f_ip([2,8,5])
        , f_dstr(5,mul_dstr(ds_ecstemt,1.94))
        , iy()
        ),

    'Z':      
        packline(""
        , h_main_2(11, 1,ecstemwc_1,8, 3,ecstemwc_2,6)
        , srp0(1)
        , mdrprg(4)
        , srp0(6)
        , mdrprg(9)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , ecstemt_1(9)
        , e0_cap(6)
        , ecstemt_2(3)
        , iy()
        ),

    'bracketleft':      
        packline(""
        , h_main_10(9, 1,tstemw_1,5, (0,4))
        , ix()
        #y
        , sy()
        , mdapr(0)
        , tstemt_1(7)
        , mdapr(3)
        , tstemt_2(4)
        , iy()
        ),

    'backslash':
        packline(""
        , mdapr(5)
        , mdrp0mrw(0)
        , 'SROUND 2'
        , mdrpmrb(1)
        , mdrp0rg(2)
        , mdrpmrb(3)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , mdapr(3)
        , iy()
        ),

    'bracketright':
        packline(""
        , h_main_01(9, (1,5) ,3,tstemw_2,7)
        , ix()
        #y
        , sy() 
        , mdapr(1)
        , tstemt_1(2)
        , mdapr(6)
        , tstemt_2(5)
        , iy()
        ),  

    'asciicircum':      
        packline(""
        , mdapr(8)
        , mdrp0mrw(0)
        , 'SROUND 1', mdrpmrb(1), 'RTG'
        , ip_round(7,0,4)
        , 'SROUND 1', mdrpmrb(3), 'RTG'
        , add_ip(3,1,[2])
        , srp0(2)
        , mdrpb(5)
        , mdrpb(6)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , alignrp(3)
        , mdapr(8)
        , e0_cap(6)
        , mdrpb(2,ds_estemt, direction="-")
        , iy()
        ),

    'underscore':      
        packline(""
        , mdapr(0)
        , mdapr(1)
        , ix()
        #y
        , sy()
        , mdapr(3)
        , estemt_a_2(0)
        , iy()
        ),

    'grave':
        packline(""
        , mdapr(2)
        , tstemw_1(3)
        , mdrp0rg(0)
        , ix()
        #y
        , sy()
        , mdapr(3)
        , mdrprg(0)
        , iy()
        ),

    'a':      
        packline(""
        , h_main_2(39, 8,estemwc_1,35, (30,11,2),estemw_2,26)
        , mdrprg(19)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , mdrpg(5)
        , v_a(0,[],23,16)
        , srp0(5)
        , estemtc_1(27)
        , ip_round(23,0,11)
        , estemt_a_2(31)
        , iy()
        , v_dry_end(20)
        ),

    'b':
        packline(""
        , h_main_2(31, 1,estemw_1,(16,26,3), 20,estemwc_2,10)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , mirprg('vheight_b',3)
        , mdrpg(13)
        , v_b(0,[4,26,27,16],7,23)
        , srp0(13)
        , estemtc_max_1(17)
        , iy()
        ),

    'c':
        packline(""
        , h_main_10(27, 3,estemwc_1,16, (23,10))
        , ix()
        #y
        , sy()
        , mdapr(26)
        , mdrpg(0)
        , v_a(0,[],6,13)
        , srp0(0)
        , estemtc_1(19)
        , iy()
        ),

    'd':
        packline(""
        , h_main_2(31, 8,estemwc_1,27, (2,21,15),estemw_2,16, ds41=" ")
        , ix()
        #y  
        , sy() 
        , mdapr(0)
        , mirprg('vheight_b',16)
        , mdrpg(5)
        , v_b(0,[14,21,20,2],11,24)
        , srp0(5)
        , estemtc_1(17)
        , iy()
        ),  

    'e':
        packline(""
#        , srp0(30)
#        , mdrp0mrw(10)
#        , estemwc_2(22)
#        , mdrprg(19)
#        , ip_round(29,10,3)
#        , estemwc_1(11)
#        , shprp2(28)
, h_main_2(30, 3,estemw_1,(11,28), 22,estemw_2,10)
, srp0(10)
, mdrprg(19)
        , ix()
        #y  
        , sy()
        , mdapr(29)
        , mdrpg(0)
        , v_a(0,[],6,25)
        , srp0(0)
        , estemtc_1(15)
        , ip_round(6,0,28)
        , estemt_a_2(11)
        , iy()
        ),

    'f':
        packline(""
        , h_main_1(25, (1,5),estemw_1,(23,20))
        , h_serif(3)
        , mdrprg(22)
        , mdrprg(13)
        , ix()
        #y  
        , sy()
        , mdapr(0)
        , e0_vheight(20)
        , alignrp(4)
        , estemt_mid_2(23)
        , shprp2(2)
        , mdrp0rg(9)
        , estemtc_2(16)
        , iy()
        , v_dry_end(12)
        ),

    'g':
        packline(""
        , h_main_2(43, 3,estemwc_1,39, (26,33,10),estemw_2,11)
        , mdrprg(18)
        , ix()
        #y
        , sy()
        , mdapr(42)
        , mdrprg(15)
        , mdrprg(0)
        , v_b(10,[9,33,32,26],6,36)
        , srp0(0)
        , estemtc_max_1(29)
        , srp0(15)
        , estemtc_1(22)
        , iy()
        ),

    'h':
        packline(""
        , h_main_2(21, 10,estemw_1,(8,12), 1,estemw_2,19)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , alignrp(9)
        , mirprg('vheight_b',12)
        , v_b(0,[13,8],16,5)
        , iy()
        ),

    'i':
        packline(""
        , h_main_1(9, (1,5),estemw_1,(3,7))
        , ix()
        #y
        , sy()
        , mdapr(0)
        , e0_vheight(3)
        , mdrp0mrw(4)
        , mdrprg(7)
        , iy()
        ),

    'j':
        packline(""
        , h_main_1(21, (10,17),estemw_1,(12,15))
        , mdrprg(4)
        , ix()
        #y
        , sy()
        , mdapr(20)
        , e0_vheight(12)
        , mdrp0mrw(16)
        , mdrprb(19)
        , srp0(20)
        , mdrp0rg(0)
        , estemtc_1(7)
        , iy()
        ),

    'k':
        packline(""
        , h_main_10(13, 5,estemw_1,(3,7), 10)
        , srp0(10)
        , mdrpb(9,ds_estemw,direction='-')
        , mdrpg(0)
        , srp0(9)
        , mdrpg(1)
        , srp0(3)
        , mdrpb(11,ds_estemw)
        , f_ip([2])
        , ix()
        #y
        , sy() 
        , mdapr(0)
        , alignrp(4)
        , mirprg('vheight_b',7)
        , e0_vheight(10)
        , f_ip([8,3])
        , f_dstr(8,ds_estemw)
        , f_dstr(3,ds_estemw,direction='-')
        , add_ip(8,3,[11,2])
        , iy()
        ),  

    'l':
        packline(""
        , h_main_1(6, 1,estemw_1,3)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , mirprg('vheight_b',3)
        , iy()
        ),

    'm':
        packline(""
        , f_dstr(39,"10-8 11+8 13+8 ")
        , h_main_2(39, 22,estemw_1,(20,24), 1,estemw_2,37,ds41="15+8 17-8 19-8 21-8 24-8 ")
#        , ip_round(22,1,13)
, add_ip(22,1,[13])
, srp0(13)
        , estemw_1(11)
        , f_ip([31])
        , ix()
        #y
        , sy()
        , mdapr(0)
        , alignrp(12)
        , alignrp(21)
        , v_b(24,[20,25,9,31],(28,34),(17,5))
        , iy()
        ),

    'n':
        packline(""
        , h_main_2(21, 10,estemw_1,(8,12), 1,estemw_2,19)
        , ix()
        #y
        , sy() 
        , mdapr(0)
        , alignrp(9)
        , v_b(12,[8,13],16,5)
        , iy()
        ),

    'o':
        packline(""
        , h_main_2(25, 3,estemwc_1,21, 15,estemwc_2,9)
        , ix()
        #y
        , sy() 
        , mdapr(24)
        , mdrpg(0)
        , v_a(0,[],6,18)
        , srp0(0)
        , estemtc_1(12)
        , iy()
        ),

    'p':
        packline(""
        , h_main_2(31, 1,estemw_1,(16,26,3), 20,estemwc_2,10)
        , ix()
        #y
        , sy()
        , mdapr(30)
        , mirprg('vheight_p',0)
        , mdrpg(13)
        , v_b(3,[4,26,27,16],7,23)
        , srp0(13)
        , estemtc_1(17)
        , iy()
        ),

    'q':
        packline(""
        , h_main_2(31, 8,estemwc_1,27, (2,21,15),estemw_2,16)
        , ix()
        #y  
        , sy()
        , mdapr(30)
        , mirprg('vheight_p',1)
        , mdrpg(5)
        , v_b(15,[14,21,20,2],11,24)
        , srp0(5)
        , estemtc_1(17)
        , iy()
        ),

    'r':
        packline(""
        , h_main_10(19, 1,estemw_1,(17,3), 11)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , v_a(3,[4,17],7,14)
        , iy()
        ),

    's':
        packline(""
        , h_main_2(37, 15,estemwc_1,28, 10,estemwc_2,33)
        , mdrprg(4)
        , srp0(33)
        , mdrprg(22)
        , add_ip(28,10,[30,31,12,13])
        , ix()
        #y
        , sy()
        , mdapr(36)
        , mdrpg(0)
        , v_a(0,[31],18,25)
        , srp0(0)
        , estemtc_1(7)
        , srp0(31)
        , estemt_2(13)
        , iy()
        ),

    't':
        packline(""
        , h_main_10(25, (3,7),estemw_1,(13,9), (21,12), ds31="14+8 15+8 ")
        , h_serif(5)
        , ix()
        #y  
        , sy()
        , mdapr(24)
        , mdrpg(0)
        , e0_vheight(10)
        , alignrp(7)
        , estemt_mid_2(13)
        , shprp2(4)
        , mdrprg(9)
        , srp0(0)
        , estemtc_1(17)
        , iy()
        ),

    'u':
        packline(""
        , h_main_2(21, 8,estemw_1,10, (17,1),estemw_2,19)
        , ix()
        #y
        , sy() 
        , mdapr(0)
        , mirprg('vheight',19)
        , f_ip([17,2])
        , shprp2(10)
        , mdrp0g(5)
        , estemtc_max_1(14)
        , iy()
        ),

    'v':
        packline(""
#        , srp0(8)
#        , mdrp0mrw(6)
#        , estemwc_2(5)
#        , 'RDTG'
#        , ip_round(7,5,2)
#        , 'RTG'
#        , estemwc_1(3)
, h_lap_2(8, 2,estemwc_1,3, 5,estemwc_1,6)
        , add_ip(3,5,[4])
        , srp0(4)
        , mdrpg(1)
        , mdrpg(0)
        , ix()
        #y
        , sy() 
        , mdapr(0)
        , mirprg('vheight',5)
        , shprp2(3)
#        , mdrpb(4,"9-2 10-2 11-3 12-3 13-3 14-5 15-5 ")
, f_ip([4])
, f_dstr(4,mul_dstr(ds_estemw,3.1718))
        , iy()
        ),

    'w':
        packline(""
#        , srp0(14) 
#        , mdrp0mrw(12)
#        , estemwc_2(11)
#        , 'RDTG'  
#        , ip_round(13,11,5)
#        , 'RTG'
#        , estemwc_1(6)
, h_lap_2(14, 5,estemwc_1,6, 11,estemwc_1,12)
        , add_ip(6,11,[7,2,10])
        , srp0(7)
        , mdrpg(4)
        , mdrpg(3)
        , srp0(2)
        , mdrpg(8)
        , mdrpg(9)
        , srp0(10)
        , mdrpg(1)
        , mdrpg(0)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , alignrp(3)
        , mirp0rg('vheight',11)
        , alignrp(8)
        , alignrp(5)
        , f_ip([2,7])
#        , mdrpb(7,"9-2 10-2 11-4 12-4 13-4 14-6 15-6 ")
#        , mdrpb(2,"9-2 10-2 11-4 12-4 13-4 14-6 15-6 ",direction="-")
, f_dstr(7,mul_dstr(ds_estemw, 2.6683))
, f_dstr(2,ds_estemw , direction="-")
        , srp0(7)
        , alignrp(10)
        , iy()
        ),

    'x':
        packline(""
#, srp0(13)
#, mdrp0mrw(9)
#, 'SROUND 68'
#, ip_round(12,9,6)
#, 'RTG'
#, mdrpg(4)
#, mdrpb(7,ds_tstemw)
#, mdrpg(3)
#, srp0(9)
#, mdrpg(1)
#, mdrp0b(10,ds_tstemw)
#, mdrpg(0)
#, add_ip(7,9,[8])
#, srp0(8)
#, alignrp(2)
#, mdrpb(5)
#, mdrpb(11)
, h_lap_2(13, 6,ds_estemw,7, 9,ds_estemw,10)
, srp0(6)
, mdrpg(4)
, srp0(7)
, mdrpg(3)
, srp0(9)
, mdrpg(1)
, srp0(10)
, mdrpg(0)
#        , srp0(13)
#        , mdrp0mrw(0)
#        , alignrp(10)
#        , mdrpmb(1,ds_estemw,direction='-')
#        , shprp2(9)
#        , 'RDTG'
#        , ip_round(12,1,4)
#        , 'RTG'
#        , alignrp(6)
#        , mdrpmb(3,ds_estemw)
#        , shprp2(7)
        , add_ip(3,1,[2])
        , srp0(2)
        , alignrp(8)
        , mdrpg(5,mul_dstr(ds_estemw,0.64),direction="-")
        , mdrpg(11,mul_dstr(ds_estemw,0.64))
        , ix()
        #y
        , sy()
        , mdapr(0)
        , alignrp(3)
        , mirprg('vheight',10)
        , shprp2(7)
        , f_ip([2,5,11,8])
#        , mdrpb(8,"9-2 10-2 11-3 12-3 13-3 14-5 15-5 ")
#        , mdrpb(2,"9-2 10-2 11-3 12-3 13-3 14-5 15-5 ",direction='-')
, f_dstr(8,mul_dstr(ds_estemw,1.56))
, f_dstr(2,mul_dstr(ds_estemw,1.56) , direction='-')
        , iy()
        ),

    'y':
        packline(""
#        , srp0(21)
#        , mdrp0mrw(16)
#        , estemwc_2(15)
#        , 'RDTG'
#        , ip_round(20,15,12)
#        , 'RTG'
#        , estemwc_1(13)
#        , mdrprg(4)
#        , add_ip(13,15,[14])
#        , srp0(14)
#        , mdrpg(11)
#        , mdrp0g(17)
#        , estemwc_2(10)
, h_lap_2(9, 3,estemwc_1,4, 6,estemwc_1,7)
, add_ip(4,6,[5])
, srp0(5)
, mdrpg(2,mul_dstr(ds_estemwc,0.391),direction="-")
, mdrp0g(0,mul_dstr(ds_estemwc,0.391/1.42))
, srp0(0)
, estemwc_2(1)
        , ix()
        #y
        , sy()
#        , mdapr(20)
#        , mirprg('vheight',15)
#        , shprp2(13)
#        , f_ip([11,14])
#        , mdrp0rg(0)
#        , f_ip([10,17])
#        , estemtc_1(7)
#        , f_dstr(14,"9-2 10-2 11-3 12-3 13-3 14-5 15-5 ")
, mdapr(8)
, e0_vheight(7)
, alignrp(4)
, f_ip([5,2])
, srp0(8)
, mdrp0rg(0)
, f_dstr(5, mul_dstr(ds_estemw,2.85))
        , iy()
        ),

    'z':
        packline(""
        , srp0(11)
        , mdrp0mrw(7)
        , alignrp(0)
        , mdrpmb(3,mul_dstr(ds_estemt,1.77),direction='-')
        , 'SROUND 70'
        , ip_round(10,0,1)
        , 'RTG'
        , alignrp(4)
        , mdrpmb(8,mul_dstr(ds_estemt, 1.77))
        , ix()
        #y
        , sy()
        , mdapr(0)
        , estemt_1(9)
        , e0_vheight(6)
        , estemt_2(3)
        , iy()
        ),

    'braceleft':      
        packline(""
        , srp0(38)
        , mdrp0mrw(0)
        , alignrp(20)
        , mdrp0rg(9)
        , mdrprb(28,ds_ecstemw)
        , ip_round(10,20,4)
        , alignrp(14)
        , tstemw_1(31)
        , shprp2(24)
        , ix()
        #y
        , sy()
        , mdapr(10)
        , estemt_2(9)
        , f_ip([28])
        , mdrp0rg(19)
        , estemt_a_2(20)
        , srp0(9)
        , mdrp0rg(0)
        , mdapr(0)
        , estemt_a_1(36)
        , iy()
        ),

    'bar':      
        packline(""
        , ip_round(4,5,1)
        , mdrpmrb(3)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , mdapr(3)
        , iy()
        ),

    'braceright':      
        packline(""
        , srp0(38)
        , mdrp0mrw(29)
        , mdrprb(10,ds_ecstemw,direction="-")
        , mdrp0rg(1)
        , alignrp(18)
        , ip_round(1,29,33)
        , alignrp(23)
        , tstemw_2(6)
        , shprp2(13)
        , ix()
        #y
        , sy()
        , mdapr(28)
        , estemt_2(29)
        , f_ip([10])
        , mdrp0rg(19)
        , estemt_a_2(18)
        , srp0(29)
        , mdrp0rg(1)
        , mdapr(1)
        , estemt_a_1(2)
        , iy()
        ),

    'asciitilde':      
        packline(""
        , srp0(25)
        , mdrp0mrw(21)
        , ip_round(24,21,8)
        , add_ip(8,21,[2,3,14,15])
        , ix()
        #y
        , sy()
        , mdapr(0)
        , ecstemtc_1(17)
        , mdrp0mrg(12)
        , ecstemtc_2(5)
        , add_ip(12,0,[2,3,14,15])
        , iy()
        ),

# BEGIN THAI
    'uni0E01':      #KO KAI
        packline(""
        , h_main_2(28, 15,tstemw_1,13, 1,tstemw_2,26)
        , h_notch_ko(15, 20,8,19,9)
        , ix()
        #y
        , sy()
        , mdapr(1)
        , alignrp(14)
        , v_ko(0,[8,9,10,13,16,19,20],23,5)
        , iy()
        ),

    'uni0E02':      #KHO KHAI
        packline(""
        , h_main_2(51, 3,tstemw_1,33, 35,tstemw_2,37, ds41="9-8 10-8 ")
        , h_serif(1)
        , ip_round(50,3,22)
        , v_head_1(47,41,16)
        , ip_round(16,35,9)
        , tstemwc_1(28)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , tstemt_1(35)
        , shprp2(3)
        , v_khai(37, [], 25,12)
        , 'SROUND 68'
        , mdrp0rg(44)
        , mdapr(44)
        , 'RTG'
        , hsph0_2(19)
        , headstem_1(38)
        , iy()
        ),

    'uni0E03':      #KHO KHUAT
        packline(""
        , h_main_2(55, 3,tstemw_1,37, 39,tstemw_2,41, ds41="9-8 ")
        , h_serif(1)
        , h_head_khuat(54,3,24, 51,45,18, 39,9,32, [27,28,29,11,12,13])
        , ix()
        #y
        , sy()
        , mdapr(0)
        , tstemt_1(39)
        , shprp2(3)
        , v_khai(41, [], (29,27),(11,13))
        , v_head_khuat(29, 28,12, 15, 48,42,21)
        , iy()
        ),

    'uni0E04':      #KHO KHWAI
        packline(""
        , h_main_2(53, 33,tstemwc_1,8, 1,tstemw_2,39)
        , mdrp0rg(27)
        , tstemw_1(25)
        , f_ip([11])
        , 'SROUND 70'
        , ip_round(8,1,17)
        , 'RTG'
        , headstem_2(43)
        , hsph0_2(49)
        , mdrpmb(12)
        , f_ip([22])
        , ix()
        #y
        , sy()
        , mdapr(1)
        , alignrp(26)
        , v_ko(0,[14,11],36,5)
        , 'SROUND 70'
        , mdapr(14)
        , 'RTG'
        , shift(16,14)
        , v_head_2(46,40,20)
        , iy()
        ),

    'uni0E05':      #KHO KHON
        packline(""
        , h_main_2(57, 35,tstemwc_1,10, 1,tstemw_2,43)
        , mdrp0rg(29)
        , tstemw_1(27)
        , f_ip([13])
        , 'SROUND 70'
        , ip_round(10,1,19)
        , 'RTG'
        , headstem_2(47)
        , hsph0_2(53)
        , mdrpmb(14)
        , f_ip([24])
        , add_ip(10,1,[38,39,40,5,6,7])
        , ix()
        #y
        , sy()
        , mdapr(1)
        , alignrp(28)
        , v_ko(0,[],(40,38),(5,7))
        , mdrp0mrg(39)
        , mdapr(39)
        , tstemt0_2(6)
        , ip_round(6,1,16)
        , shift(16,16)
        , v_head_2(50,44,22)
        , add_ip(16,1,[13])
        , iy()
        ),

    'uni0E06':      #KHO RAKHANG
        packline(""
        , h_main_2(76, 13,tstemw_1,(47,4), (51,1),tstemw_2,53, ds41="10-8 ")
        , mdrp0rg(10)
        , headstem_1(72)
        , hsph_1(68)
        , h_head_khuat(75,13,34, 63,57,28, 51,19,42, [37,38,39,21,22,23])
        , ix()
        #y
        , sy()
        , mdapr(0)
        , mdrpg(7)
        , tstemt_1(51)
        , v_khai(53, [], (39,37),(21,23))
        , v_head_khuat(39, 38,22, 25, 60,54,31)
        , srp0(7)
        , headstem_2(66)
        , 'SROUND 70'
        , mdrp0rg(70)
        , mdapr(70,"9+4 10+4 11-4 12-4 ")
        , 'RTG'
        , headstem0_2(13)
        , mdrpg(48)
        , mdrpg(4)
        , iy()
        ),

    'uni0E07':      #NGO NGU
        packline(""
        , h_main_01(45, 6, 16,tstemw_2,28)
        , srp0(28)
        , h_head_1r(22,41,35)
        , add_ip(6,28,[4,3])
        , srp0(4)
        , mdrpb(9,ds_tstemw)
        , srp0(3)
        , mdrpb(10,ds_tstemw)
        , ix()
        #y
        , sy()
        , mdapr(44)
        , mdrpg(0)
        , v_ngo(0,[],25)
        , v_head_2(38,32,19)
        , srp0(0)
        , tstemtc_1(13)
        , iy()
        ),

    'uni0E08':      #CHO CHAN
        packline(""
        , h_main_01(53, 29, 22,tstemw_2,36,ds31="14+8 16+8 ")
        , mdrp0rg(9)
        , headstem_1(49)
        , hsph0_1(43)
        , mdrp0mb(15)
        , mdrpb(4,ds_tstemw,direction="-")
        , add_ip(4,22,[3])
        , srp0(3)
        , mdrpb(16,ds_tstemw)
        , ix()
        #y
        , sy()
        , mdapr(52)
        , mdrpg(0)
        , v_ko(0,[12],33,26)
        , 'SROUND 73'
        , mdapr(12)
        , 'RTG'
        , shift(16,12)
        , v_head_2(46,40,6)
        , srp0(0)
        , tstemtc_1(19)
        , iy()
        ),

    'uni0E09':      #CHO CHING
        packline(""
#        , h_main_2(71, 1,tstemw_1,(13,0), 17,tstemw_2,31, ds41="15+8 ")
#        , mdrprg(24)
#        , h_head_2(7,55,49)
, ht_main_head(71, 7,55,49, 1,(13,0), 17,31)
, srp0(7)
, mdrprg(24)
        , srp0(31)
        , mdrp0rg(35,"9+3 10-5 11-5 12-5 13-5 14-5 ")
        , v_head_2(61,67,43)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , tstemt_1(14)
        , mdrpg(38)
        , v_ko(0,[10],28,21)
        , 'SROUND 73'
        , mdapr(10,"12-8 13-8 ")
        , 'RTG'
        , shift(16,10)
        , v_head_2(52,46,4)
        , srp0(38)
        , v_head_1(58,64,17)
        , f_ip([32])
        , f_dstr(17,"9+5 10+5 11+5 12+5 13+5 ")
        , srp0(17)
        , mdrpb(43)
        , iy()
        ),

    'uni0E0A':      #CHO CHANG
        packline(""
        , h_main_2(64, 3,tstemw_1,33, 35,tstemw_2,50, "9-8 ")
        , h_serif(1)
        , 'RDTG'
        , ip_round(63,3,22)
        , 'RTG'
        , v_head_1(60,54,16)
        , ip_round(22,35,9)
        , tstemwc_1(28)
        , ip_round(28,35,39)
        , mdrpg(47,ds_tstemw)
        , ip_round(0,64,44)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , tstemt_1(35)
        , shprp2(3)
        , v_khai(0, [39,40,47], 25,12)
        , 'SROUND 68'
        , mdrp0rg(51)
        , 'RTG'
        , mdapr(51,"10+8 ")
        , headstem_2(19)
        , headhole_1(57)
        , iy()
        ),

    'uni0E0B':      #SO SO
        packline(""
        , h_main_2(68, 3,tstemw_1,37, 39,tstemw_2,54)
        , h_serif(1)
        , h_head_khuat(67,3,24, 64,58,18, 39,9,32, [27,28,29,11,12,13])
        , ip_round(32,39,43)
        , mdrpg(51,ds_tstemw)
        , ip_round(0,69,48)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , tstemt_1(39)
        , shprp2(3)
        , v_khai(0, [43,44,51], (29,27),(11,13))
        , v_head_khuat(29, 28,12, 15, 61,55,21)
        , iy()
        ),

    'uni0E0C':      #CHO CHOE
        packline(""
        , h_main_2(77, 37,tstemw_1,25, (52,1),tstemw_2,54)
        , h_head_1(64,58,31)
        , h_notch_ko(37, 42,20,41,22)
        , 'SROUND 74'
        , ip_round(37,52,13,"10-8 ")
        , 'RTG'
        , tstemw_1(48)
        , shprp2(4)
        , srp0(13)
        , mdrp0mrg(10," ")
        , headstem0_1(73)
        , mdrpg(69)
        , ix()
        #y
        , sy() 
        , mdapr(1)
        , mdrpg(7)
        , shprp2(34)
        , tstemt_1(52)
        , v_ko(54,[20,21,22,25,38,41,42],45,17)
        , srp0(7)
        , v_head_1((67,55),61,13)
        , f_dstr(13,"9+8 ")
        , srp0(7)
        , 'SROUND 70'
        , mdrp0rg(13)
        , mdapr(13)
        , 'RTG'
        , mdrpg(49)
        , headstem0_2(71)
        , mdrpg(4)
        , iy()
        ),

    'base.uni0E0D.descless':      #YO YING
        packline(""
        , h_main_2(54, 25,tstemw_1,13, 38,tstemw_2,40)
        , h_head_1(50,44,19)
        , h_notch_ko(25, 30,8,29,10)
        , ip_round(25,38,1)
        , 'RTG'
        , tstemw_1(36)
        , ix()
        #y
        , sy() 
        , mdapr(1)
        , mdrpg(22)
        , tstemt_1(37)
        , v_ko(40,[8,9,10,13,26,29,30],33,5)
        , srp0(22)
        , v_head_1(41,47,16)
        , iy()
        ),

    'desc.uni0E0D':      #YO YING
        packline(""
        , srp0(33)
        , mdrp0mrw(15)
        , mdrp0rg(3)
        , mdrpb(29)
        , mdrp0rg(23)
        , mdrpb(9)
        , ix()
        #y
        , sy()
        , mdapr(6)
        , alignrp(15)
        , mdrpb(26)
        , mdrp0rg(20)
        , srp0(6)
        , mdrp0rg(0)
        , mdrpb(13)
        , iy()
        ),

    'uni0E0E':      #DO CHADA
        packline(""
#        , h_main_2(79, 42,tstemw_1,30, (18,1),tstemw_2,53)
#        , h_head_2(37,63,57)
, ht_main_head(79, 37,63,57, 42,30, (18,1),53)
        , h_notch_ko(42, 47,25,46,27)
        , srp0(53)
        , mdrp0rg(8)
        , f_ip([69,14,17,2])
        , mdrpg(75)
        , ix()
        #y  
        , sy() 
        , mdapr(78)
        , mdrpg(34)
        , mirpmrg('vheight_lu',1)
        , shprp2(5)
        , v_ko(0,[25,26,27,30,43,46,47],50,22)
        , srp0(34)
        , v_head_1(54,60,40)
        , srp0(1)
        , mdrpmb(18)
        , mdrpmb(66)
        , mdrp0rg(72)
        , mdrpmb(11)
        , add_ip(5,11,[69,14,17,2])
        , iy()
        ),

    'uni0E0F':      #TO PATAK
        packline(""
#        , h_main_2(83, 46,tstemw_1,34, (22,1),tstemw_2,57)
#        , h_head_2(41,67,61)
, ht_main_head(83, 41,67,61, 46,34, (22,1),57)
        , h_notch_ko(46, 51,29,50,31)
        , srp0(57)
        , mdrp0rg(10)
        , f_ip([73,16,19,4,20,21,2,3])
        , mdrpg(79)
        , ix()
        #y  
        , sy() 
        , mdapr(82)
        , mdrpg(38)
        , mirpmrg('vheight_lu',1)
        , shprp2(3)
        , shprp2(7)
        , v_ko(0,[29,30,31,34,47,50,51],54,26)
        , srp0(38)
        , v_head_1(58,64,44)
        , srp0(1)
        , mdrpmb(22)
        , mdrpmb(70)
        , mdrp0rg(76)
        , mdrpmb(13)
        , add_ip(7,13,[73,16,19,4,20,21,2])
        , iy()
        ),

    'base.uni0E10.descless':      #THO THAN
        packline(""
        , h_main_2(75, 29,tstemwc_1,52, 22,tstemw_2,58)
        , mdrp0rg(9)
        , headstem_1(71)
        , hsph0_1(65)
        , mdrp0mb(15)
        , mdrpb(4,ds_tstemw,direction="-")
        , add_ip(4,22,[3])
        , srp0(3)
        , mdrpb(16,ds_tstemw)
        , srp0(76)
        , mdrpmrw(41)
        , ix()
        #y
        , sy()
        , mdapr(74)
        , mdrpg(0)
        , v_top('vheight',0, [], 32)
        , tstemt_mid_2(49)
        , mdrp0rg(55)
        , mdapr(55)
        , tstemt_mid_2(26)
        , mdrp0rg(12)
        , shift(12,16)
        , v_head_2(68,62,6)
        , srp0(0)
        , tstemtc_1(19)
        , iy()
        ),

    'desc.uni0E10':      #THO THAN
        packline(""
        , srp0(65)
        , mdrp0mrw(37)
        , mdrpb(26)
        , mdrpb(44)
        , mdrp0rg(50)
        , mdrpb(31)
        , srp0(37)
        , mdrp0rg(12)
        , mdrpb(62)
        , add_ip(62,26,[56,18,21,23,24,2,6])
        , ix()
        #y
        , sy()
        , mdapr(34)
        , mdrpb(47)
        , mdrp0rg(41)
        , mdrpb(28)
        , srp0(34)
        , mdrp0rg(0)
        , alignrp(3)
        , alignrp(9)
        , mdrpb(26)
        , mdrpb(23)
        , mdrpb(53)
        , mdrp0rg(59)
        , mdrpb(15)
        , add_ip(15,9,[56,18,21,24,2,6])
        , iy()
        ),

    'uni0E11':      #THO NANGMONTHO
        packline(""
        , h_main_2(66, 9,tstemw_1,(43,8), 1,tstemw_2,52)
        , h_head_khuat(65,9,30, 62,56,24, 1,15,38, [33,34,35,17,18,19])
        , ix()
        #y  
        , sy() 
        , mdapr(1)
        , alignrp(8)
        , tstemt_1(46)
        , v_khai(0, [], (35,33),(17,19))
        , v_head_khuat(35, 34,18, 21, 59,53,27)
        , srp0(35)
        , mdrp0g(49)
        , tstemtc_2(5)
        , iy()
        ),

    'uni0E12':      #THO PHUTHAO
        packline(""
        , h_main_2(89, 52,tstemwc_1,22, (64,1),tstemw_2,66)
        , mdrp0rg(46)
        , tstemw_1(44)
        , f_ip([27])
        , ip_round(52,64,13)
        , tstemw_1(60)
        , shprp2(4)
        , mdrp0rg(10)
        , headstem_1(85)
        , hsph_1(81)
        , 'SROUND 70'
        , ip_round(22,13,39)
        , 'RTG'
        , v_head_2(70,76,33)
        , ix()
        #y
        , sy()
        , mdapr(1)
        , alignrp(45)
        , mdrpg(7)
        , tstemt_1(64)
        , v_ko(66,[27],(57,55),(17,19))
        , mdrp0mrg(56)
        , mdapr(56)
        , tstemt0_2(18)
        , ip_round(18,1,36)
        , shift(16,36)
        , headstem_2(73)
        , hsph0_2(67)
        , mdapr(67)
        , mdrpg(30)
        , mdrpg(40)
        #
        , srp0(7)
        , headstem_1(80)
        , mdrp0rg(83,"10-8 11-8 ")
        , alignrp(4)
        , headstem_1(13)
        , shprp2(61)
        , iy()
        ),

    'uni0E13':      #NO NEN
        packline(""
        , h_main_2(77, 25,tstemw_1,13, (40,52),tstemw_2,(42,73), ds41="",ds4x="15-8 ")
        , h_head_1(64,58,19)
        , h_notch_ko(25, 30,8,29,9)
        , ip_round(25,40,1,"10-8 ")
        , tstemw_1(36)
        , shprp2(0)
        , srp0(42)
        , mdrp0rg(46)
        , headstem_2(70)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , tstemt_1(37)
        , mdrpg(22)
        , shprp2(49)
        , v_ko(42,[8,9,10,13,26,29,30],33,5)
        #
        , srp0(22)
        , v_head_1((55,68),61,16)
        #
        , srp0(49)
        , mdrp0rg(73)
        , alignrp(52)
        , headstem_1(43)
        , shprp2(40)
        , iy()
        ),

    'uni0E14':      #DO DEK
        packline(""
        , h_main_2(58, 38,tstemwc_1,8, 1,tstemw_2,44)
        , mdrp0rg(32)
        , tstemw_1(30)
        , f_ip([13])
        , 'SROUND 70'
        , ip_round(8,1,25)
        , 'RTG'
        , v_head_2(48,54,19)
        , f_ip([16])
        , ix()
        #y
        , sy()
        , mdapr(1)
        , alignrp(31)
        , v_ko(0,[22],41,5)
        , 'SROUND 70'
        , mdapr(22)
        , 'RTG'
        , shift(16,22)
        , headstem_2(51)
        , hsph0_2(45)
        , mdapr(45)
        , mdrpg(16)
        , mdrpg(26)
        , add_ip(22,1,[13])
        , iy()
        ),

    'uni0E15':      #TO TAO
        packline(""
        , h_main_2(62, 40,tstemwc_1,10, 1,tstemw_2,48)
        , mdrp0rg(34)
        , tstemw_1(32)
        , f_ip([15])
        , 'SROUND 70'
        , ip_round(10,1,27)
        , 'RTG'
        , v_head_2(52,58,21)
        , f_ip([18])
        , add_ip(10,1,[43,44,45,5,6,7])
        , ix()
        #y
        , sy()
        , mdapr(1)
        , alignrp(33)
        , v_ko(0,[15],(45,43),(5,7))
        , mdrp0mrg(44)
        , mdapr(44)
        , tstemt_2(6)
        , ip_round(6,1,24)
        , shift(16,24)
        , headstem_2(55)
        , hsph0_2(49)
        , mdapr(49)
        , mdrpg(18)
        , mdrpg(28)
        , iy()
        ),

    'uni0E16':      #THO THUNG
        packline(""
        , h_main_2(50, 25,tstemw_1,13, 1,tstemw_2,36)
        , h_head_1(46,40,19)
        , h_notch_ko(25, 30,8,29,9)
        , ix()
        #y
        , sy()
        , mdapr(1)
        , mdrpg(22)
        , v_ko(0,[8,9,10,13,26,29,30],33,5)
        , srp0(22)
        , v_head_1(37,43,16)
        , iy()
        ),

    'uni0E17':      #THO THAHAN
        packline(""
#        , h_main_2(44, 9,tstemw_1,(21,8), 1,tstemw_2,30)
#        , h_head_2(15,40,34)
, ht_main_head(44, 15,40,34, 9,(21,8), 1,30)
        , ix()
        #y  
        , sy() 
        , mdapr(1)
        , alignrp(8)
        , tstemt_1(24)
        , v_ko(0,[],(27,18),5)
        , v_head_2(37,31,12)
        , iy()
        ),

    'uni0E18':      #THO THONG
        packline(""
        , h_main_2(44, 3,tstemw_1,41, 37,tstemw_2,36,ds41="10-8 17-8 ")
        , h_serif(1)
        , ip_round(45,3,7)
        , tstemwc_1(30)
        , srp0(44)
        , mdrpmrw(19)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , tstemt_1(37)
        , shprp2(3)
        , v_top('vheight',0, [], 10)
        , tstemt_mid_2(27)
        , mdrp0rg(33)
        , tstemt_mid_2(41)
        , shprp2(4)
        , iy()
        ),

    'uni0E19':      #NO NU
        packline(""
#        , h_main_2(59, 1,tstemw_1,(0,13), 17,tstemw_2,19)
#        , h_head_2(7,43,37)
, ht_main_head(59, 7,43,37, 1,(13,0), 17,19)
        , srp0(19)
        , mdrp0rg(23,"9+3 10+3 11+3 12+3 13+3 14-5 15-5 16-5 17-5 ")
        , v_head_2(49,55,31)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , mdrpg(14,ds_tstemt)
        , mdrpg(26)
        , v_ngo(19,[],10)
        , v_head_2(40,34,4)
        , srp0(26)
        , v_head_1(46,52,17)
        , f_dstr(17,"9+6 10+4 11+4 12+6 13+8 ")
        , f_ip([20])
        , srp0(17)
        , mdrpg(31)
        , iy()
        ),

    'uni0E1A':      #BO BAIMAI
        packline(""
#        , h_main_2(33, 3,tstemw_1,15, 17,tstemw_2,19)
#        , h_serif(1)
#        , h_head_2(9,29,23)
, ht_main_head(33, 9,29,23, 3,15, 17,19)
, h_serif(1)
        , ix()
        #y
        , sy()
        , mdapr(1)
        , tstemt_1(2)
        , shprp2(17)
        , v_ngo(19,[],12)
        , v_head_2(26,20,6)
        , iy()
        ),

    'uni0E1B':      #PO PLA
        packline(""
#        , h_main_2(33, 3,tstemw_1,15, 17,tstemw_2,19)
#        , h_serif(1)
#        , h_head_2(9,29,23)
, ht_main_head(33, 9,29,23, 3,15, 17,19)
, h_serif(1)
        , ix()
        #y
        , sy() 
        , mdapr(1)
        , tstemt_1(2)
        , shprp2(17)
        , mirprg("vheight_po",19)
        , v_ngo(0,[],13)
        , v_head_2(26,20,6)
        , iy()
        ),

    'uni0E1C':      #PHO PHUNG
        packline(""
        , h_main_2(60, 14,tstemw_1,(26,13), (44,1),tstemw_2,46)
        , h_head_1(56,50,21)
        , add_ip(26,44,[2,31,35,36,40])
        , ix()
        #y  
        , sy()
        , mdapr(1)
        , alignrp(13)
        , tstemt_1(42)
        , shprp2(29)
        , v_ngo(46,[],18)
        , v_head_2(53,47,24)
        , ip_round(18,1,36)
        , mdapr(36)
        , mdrpg(7)
        , iy()
        ),

    'uni0E1D':      #FO FA
        packline(""
        , h_main_2(60, 14,tstemw_1,[26,13], [44,1],tstemw_2,46)
        , h_head_1(56,50,21)
        , add_ip(26,44,[2,31,35,36,40])
        , ix()
        #y  
        , sy()
        , mdapr(1)
        , alignrp(13)
        , tstemt_1(42)
        , shprp2(29)
        , mirprg('vheight_po',46)
        , v_ngo(0,[],18)
        , v_head_2(53,47,24)
        , ip_round(18,1,36)
        , mdrpg(7)
        , iy()
        ),

    'uni0E1E':      #PHO PHAN
        packline(""
#        , h_main_2(60, 14,tstemw_1,(26,13), (44,1),tstemw_2,46)
#        , h_head_2(20,56,50)
, ht_main_head(60, 20,56,50, 14,(26,13), (44,1),46)
        , add_ip(26,44,[2,31,35,36,40])
        , ix()
        #y  
        , sy() 
        , mdapr(1)
        , alignrp(13)
        , tstemt_1(42)
        , shprp2(29)
        , v_ngo((46,36),[],23)
        , v_head_2(53,47,17)
        , srp0(36)
        , mdrpg(7)
        , iy()
        ),

    'uni0E1F':      #FO FAN
        packline(""
#        , h_main_2(60, 14,tstemw_1,[26,13], [44,1],tstemw_2,46)
#        , h_head_2(20,56,50)
, ht_main_head(60, 20,56,50, 14,(26,13), (44,1),46)
        , add_ip(26,44,[2,31,35,36,40])
        , ix()
        #y  
        , sy()
        , mdapr(1)
        , alignrp(13)
        , tstemt_1(42)
        , shprp2(29)
        , mirprg('vheight_po',46)
        , v_ngo(36,[],23)
        , v_head_2(53,47,17)
        , srp0(36)
        , mdrpg(7)
        , iy()
        ),  

    'uni0E20':      #PHO SAMPHAO
        packline(""
#        , h_main_2(50, 25,tstemw_1,13, 1,tstemw_2,36)
#        , h_head_2(20,46,40)
, ht_main_head(50, 20,46,40, 25,13, 1,36)
        , h_notch_ko(25, 30,8,29,10)
        , ix()
        #y  
        , sy()
        , mdapr(1)
        , mdrpg(17)
        , v_ko(0,[],33,5)
        , srp0(17)
        , v_head_1(37,43,23)
        , iy()
        ),

    'uni0E21':      #MO MA
        packline(""
#        , h_main_2(54, 13,tstemw_1,(25,4), (29,1),tstemw_2,31)
#        , h_head_2(19,41,35)
, ht_main_head(54, 19,41,35, 13,(25,4), (29,1),31)
        , srp0(19)
        , mdrp0rg(10)
        , headstem_1(50)
        , srp0(4)
        , mdrpmb(46)
        , ix()
        #y  
        , sy()
        , mdapr(1)
        , mdrpg(7)
        , tstemt_1(29)
        , v_ngo(31,[],22)
        , v_head_2(38,32,16)
        , srp0(7)
        , headstem_1(44)
        , mdrp0rg(48,"9-4 10-4 ")
        , headstem0_1(13)
        , mdrpg(26)
        , mdrpg(4)
        , iy()
        ),

    'uni0E22':      #YO YAK
        packline(""
        , h_main_2(48, (1,8),tstemw_1,(30,20), 32,tstemw_2,34)
        , f_ip([5])
        , h_head_1(44,38,15)
        , ip_round(30,32,26)
        , ix()
        #y  
        , sy() 
        , mdapr(0)
        , tstemt_1(32)
        , v_ngo(34,[],12)
        , v_head_2(41,35,18)
        , ip_round(18,32,26)
        , mdrpmb(25)
        , f_ip([5])
        , iy()
        ),

    'uni0E23':      #RO RUA
        packline(""
        , h_main_2(61, 15,tstemwc_1,38, 8,tstemw_2,44)
        , srp0(44)
        , h_head_1r(3,57,51) 
        , srp0(61)
        , mdrpmrw(27)
        , ix()
        #y
        , sy()
        , mdapr(60)
        , mdrpg(0)
        , v_top('vheight',0, [], 18)
        , tstemt_mid_2(35)
        , mdrp0rg(41)
        , mdapr(41)
        , tstemt_mid_2(12)
        , srp0(0)
        , v_head_1(48,54,6)
        , iy()
        ),

    'uni0E24':      #RU
        packline(""
        , h_main_2(50, 25,tstemw_1,13, 1,tstemw_2,36)
        , h_head_1(46,40,19)
        , h_notch_ko(25, 30,8,29,9)
        , ix()
        #y
        , sy() 
        , mdapr(49)
        , mirprg('vheight_lu',1)
        , mdrpg(22)
        , v_ko(0,[8,9,10,13,26,29,30],33,5)
        , srp0(22)
        , v_head_1(37,43,16)
        , iy()
        ),

    'uni0E25':      #LO LING
        packline(""
        , h_main_2(57, 20,tstemw_1,8, (29,1),tstemw_2,43)
        , mdrprg(36)
        , h_head_1(53,47,14)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , mdrpg(17)
        , tstemt_1(27)
        , v_ko(0,[24],40,33)
        , mdapr(24)
        , tstemt_mid_2(5)
        , srp0(17)
        , v_head_1(44,50,11)
        , iy()
        , v_dry_end(37)
        ),

    'uni0E26':      #LU
        packline(""
#        , h_main_2(50, 25,tstemw_1,13, 1,tstemw_2,36)
#        , h_head_2(20,46,40)
, ht_main_head(50, 20,46,40, 25,13, 1,36)
        , h_notch_ko(25, 30,8,29,10)
        , ix()
        #y  
        , sy() 
        , mdapr(49)
        , mirprg('vheight_lu',1)
        , mdrpg(17)
        , v_ko(0,[],33,5)
        , srp0(17)
        , v_head_1(37,43,23)
        , iy()
        ),

    'uni0E27':      #WO WAEN
        packline(""
        , h_main_01(39, 15, 8,tstemw_2,22)
        , srp0(22)
        , h_head_1r(3,35,29)
        , ix()
        #y
        , sy() 
        , mdapr(38)
        , mdrpg(0)
        , v_ko(0,[],19,12)
        , srp0(0)
        , v_head_1(26,32,6)
        , iy()
        , v_dry_end(16)
        ),  

    'uni0E28':      #SO SALA
        packline(""
        , h_main_2(63, 33,tstemwc_1,8, 1,tstemw_2,49)
        , mdrp0rg(27)
        , tstemw_1(25)
        , f_ip([11])
        , 'SROUND 70'
        , ip_round(8,1,17)
        , 'RTG'
        , headstem_2(53)
        , hsph0_2(59)
        , mdrpmb(12)
        , ip_round(49,63,43)
        , ix()
        #y
        , sy()
        , mdapr(1)
        , alignrp(26)
        , v_ko(0,[14,11],36,5)
        , 'SROUND 70'
        , mdapr(14)
        , 'RTG'
        , shift(16,14)
        , v_head_2(56,50,20)
        , iy()
        ),

    'uni0E29':      #SO RUSI
        packline(""
#        , h_main_2(74, 3,tstemw_1,15, (17,38),tstemw_2,(48,40))
#        , h_serif(1)
#        , h_head_2(9,58,52)
, ht_main_head(74, 9,58,52, 3,15, (17,38),(48,40))
, h_serif(1)
        , srp0(40)
        , mdrp0rg(30)
        , mdrpb(64)
        , mdrp0rg(70)
        , mdrpb(24)
        , ip_round(48,74,45)
        , ix()
        #y
        , sy() 
        , mdapr(1)
        , tstemt_1(2)
        , shprp2(17)
        , v_ngo(40,[21],12)
        , v_head_2(55,49,6)
        #
        , mdapr(21)
        , mdrpmb(35)
        , mdrp0rg(27)
        , f_ip([61,18,38,41,48])
        , mdrpb(67)
        , mdapr(61)
        , iy()
        ),

    'uni0E2A':      #SO SUA
        packline(""
        , h_main_2(67, 20,tstemw_1,8, (29,1),tstemw_2,53)
        , mdrprg(36)
        , h_head_1(63,57,14)
        , ip_round(53,67,47)
        , ix()
        #y
        , sy() 
        , mdapr(0)
        , tstemt_1(27)
        , mdrpg(17)
        , v_ko(0,[24,43,50],40,33)
        , mdapr(24)
        , mdrpb(5,ds_tstemt,direction='-')
        , srp0(17)
        , v_head_1(54,60,11)
        , iy()
        , v_dry_end(37)
        ),

    'uni0E2B':      #HO HIP
        packline(""
#        , h_main_2(68, 9,tstemw_1,(21,8), 1,tstemw_2,42,"9-8 ")
#        , h_head_2(15,52,46)
, ht_main_head(68, 15,52,46, 9,(21,8), 1,42)
        , srp0(42)
        , mdrp0rg(36)
        , v_head_2(58,64,30)
        , f_dstr(30,"9-8 11-8 12-8 13-8 ")
        , f_dstr(58,"9+8 ")
        , ix()
        #y  
        , sy() 
        , mdapr(1)
        , alignrp(8)
        , tstemt_1(24)
        , v_ngo(0,[],(33,18))
        , v_head_2((61,49),(55,43),12)
        , mdrpmb(5,"9-8 10-8 11-4 12-4 13-4 ")
        , f_ip([27,38])
        , iy()
        ),

    'uni0E2C':      #LO CHULA
        packline(""
#        , h_main_2(89, 14,tstemw_1,(26,13), (44,1),tstemw_2,(63,56))
#        , h_head_2(20,73,67)
, ht_main_head(89, 20,73,67, 14,(26,13), (44,1),(63,56))
        , add_ip(26,44,[2,31,35,36,40])
        , srp0(56)
        , h_head_1r(50,85,79)
        , ip_round(63,89,60)
        , ix()
        #y  
        , sy() 
        , mdapr(1)
        , alignrp(13)
        , tstemt_1(42)
        , shprp2(29)
        , v_ngo(36,[],23)
        , v_head_2(70,64,17)
        , srp0(36)
        , mdrpg(7)
        , f_dstr(36)
        #
        , mdapr(53)
        , v_head_2(82,76,47)
        , add_ip(53,47,[56,63])
        , iy()
        ),

    'uni0E2D':      #O ANG
        packline(""
        , h_main_2(43, 1,tstemw_1,13, 15,tstemw_2,29)
        , mdrprg(22)
        , h_head_1(39,33,8)
        , ix()
        #y
        , sy() 
        , mdapr(0)
        , tstemt_1(15)
        , v_ko(0,[],26,19)
        , mdrp0rg(5)
        , 'RDTG'
        , mdapr(5,"12-8 ")
        , 'RTG'
        , shift(16,5)
        , v_head_2(36,30,11)
        , iy()
        , v_dry_end(23)
        ),  

    'uni0E2E':      #HO NOKHUK
        packline(""
        , h_main_2(67, 1,tstemw_1,13, 15,tstemw_2,41)
        , h_head_1(51,45,8)
        , srp0(1)
        , mdrp0rg(25)
        , mdrpmg(63)
        , add_ip(25,41,[57,31,38,19])
        , ip_round(41,68,35)
        , f_dstr(57,ds_tstemwc,direction='-')
        , f_dstr(38,ds_tstemwc)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , tstemt_1(15)
        , v_ngo(0,[],28)
        , mdrpmb(60)
        , mdrp0rg(54)
        , mdapr(54)
        , mdrp0mb(22)
        , ip_round(22,0,5)
        , shift(16,5)
        , v_head_2(48,42,11)
        , add_ip(28,22,[57,31,38,19])
        , iy()
        ),

    'uni0E2F':      #PAIYANNOI
        packline(""
        , h_main_01(41, 13, (3,26),tstemw_2,27)
        , v_head_1(37,31,18)
        , f_ip([23])
        , srp0(3)
        , h_serif(1)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , tstemt_1(3)
        , v_ngo(27,[],15)
        , tstemt_2(6)
        , headstem_2(34)
        , hsph_2(28)
        , mdrp0rg(9)
        , tstemtc_1(23)
        , iy()
        ),

    'uni0E30':      #SARA A
        packline(""
        , srp0(67)
        , mdrp0mrw(18)
        , alignrp(51)
        , 'SROUND 68'
        , ip_round(66,18,3)
        , 'RTG'
        , alignrp(36)
        , v_head_1((30,63),(24,57),(9,42))
        , ix()
        #y
        , sy()
        , mdapr(0)
        , mdrpmb(14)
        #, mdrp0rg(27,"9-8 10-8 11-8 12-8 15-8 21-8 ")
        , 'SROUND 70'
        , mdrp0rg(27)
        , 'RTG'
        , headstem_1(6)
        , headhole_2(21)
        #
        , mdapr(60,"10-8 ")
        , headstem_1(39)
        , headhole_2(54)
        #, mdrp0rg(33,"9-8 10-8 11-8 12-8 15-8 21-8 ",direction='-')
        , 'SROUND 70'
        , mdrp0rg(33)
        , 'RTG'
        , mdrpmb(47)
        , iy()
        ),

    'uni0E31':      #MAI HAN-AKAT
        packline(""
        , mdapr(33)
        , mdrp0mrw(9)
        , mdrprg(18)
        , v_head_2(24,30,3)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , mdrpb(14)
        , 'RDTG'
        , mdrp0rg(27)
        , 'RTG'
#        , headhole_2(21)
, f_ip([21])
        , headstem_1(6)
        , iy()
        ),

    'uni0E32':      #SARA AA
        packline(""
        , h_main_01(17, 8, 1,tstemw_2,15)
        , ix()
        #y
        , sy()
        , mdapr(1)
        , v_ko(0,[],12,5)
        , iy()
        , v_dry_end(9)
        ),

    'uni0E34':      #SARA I
        packline(""
        , mdapr(14)
        , mdrp0mrw(0)
        , mdrpb(7)
        , mdrp0rg(13)
        , mdrpb(1)
        , ix()
        #y
        , sy()
        , v_sara(0)
        , mdrpb(7)
        , mdrp0mrg(10,"15+8 ")
        , mdrpb(4)
        , iy()
        ),

    'uni0E35':      #SARA II
        packline(""
        , mdapr(17)
        , mdrp0mrw(0)
        , mdrpmb(7)
        , mdrpb(10)
        , mdrp0rg(16)
        , mdrpb(1)
        , ix()
        #y
        , sy()
        , v_sara(0)
        , mdrpb(10)
        , mdrp0mrg(13,"15+8 ")
        , mdrp0b(4)
        , mdrpmrg(9)
        , 'SROUND 73'
        , mdapr(9)
        , 'RTG'
        , iy()
        ),

    'uni0E36':      #SARA I
        packline(""
        , mdapr(37)
        , mdrp0mrw(0)
        , mdrpb(18)
        , mdrp0rg(24)
        , mdrpb(1)
        , srp0(0)
        , mdrp0mrg(12)
        , mdrpb(28)
        , mdrp0rg(34)
        , mdrpb(6)
        , ix()
        #y  
        , sy() 
        , v_sara(0)
        , mdrpb(18)
        , mdrp0mrg(21,"15+8 ")
        , mdrp0b(4)
        , mdrp0mrg(10)
        , mdapr(10)
        , mdrpb(31)
        , mdrp0mrg(25)
        , mdrpb(16)
        , iy()
        ),  

    'uni0E37':      #SARA UEE
        packline(""
        , mdapr(20)
        , mdrp0mrw(0)
        , mdrpb(13)
        , mdrp0b(11)
        , mdrp0mrg(7)
        , mdapr(7)
        , mdrpb(5)
        , srp0(0)
        , mdrp0rg(19)
        , mdrpb(1)
        , ix()
        #y  
        , sy()
        , v_sara(0)
        , mdrpb(13)
        , mdrp0mrg(16,"15+8 ")
        , mdrp0b(4)
        , mdrpmrg(5)
        , 'SROUND 73'
        , mdapr(5)
        , 'RTG'
        , alignrp(11)
        , add_ip(4,16,[7,10])
        , iy()
        ),

    'uni0E38':      #SARA U
        packline(""
        , mdapr(26)
        , mdrp0mrw(0)
        , mdrpmb(2)
        , mdrp0rg(23)
        , mdrpb(7)
        , mdrpw(16)
        , ix()
        #y
        , sy()
        , mdapr(26)
        , 'SROUND 74'
        , mdrp0rw(10)
        , 'RTG'
        , mdrpmb(20)
        , mdrp0rg(14,"9+8 10+8 ")
        , mdrp0mb(4)
        , mdrpmrg(1)
        , 'SROUND 73'
        , mdapr(1)
        , 'RTG'
        , iy()
        ),

    'uni0E39':      #SARA UU
        packline(""
        , srp0(34)
        , mdrp0mrw(19)
        , mdrpb(17)
        , mdrp0rg(13)
        , mdrpb(1)
        , mdrpb(25)
        , mdrp0rg(31)
        , mdrpb(7)
        , ix()
        #y
        , sy()
        , mdapr(34)
        , 'SROUND 74'
        , mdrp0rw(18)
        , mdrp0g(10)
        , mdrpb(28)
        , srp0(18)
        , mdrp0rg(22,"9+8 10+8 ")
        , mdrp0b(4)
        , mdrpmrg(1)
        , 'SROUND 73'
        , mdapr(1)
        , 'RTG'
        , mdrpb(14)
        , iy()
        ),

    'uni0E3A':      #PHINTHU
        packline(""
        , srp0(12)
        , mdrp0mrw(9)
        , mdrpmrb(3)
        , ix()
        #y  
        , sy()
        , mdapr(12)
        , mdrp0mrw(6)
        , mdrpmrb(0)
        , iy()
        ),

    'uni0E3F':      #THAI BAHT
        packline(""
        , srp0(50)
        , mdrp0mrw(18)
        , mdrpmb(27)
        , mdrp0rg(12)
        , mdrpmb(40)
        , 'SROUND 68'
        , ip_round(49,18,3)
        , 'RTG'
        , mdrpmb(34)
        , shprp2(47)
        , ip_round(34,40,32)
        , alignrp(2)
        , alignrp(45)
        , alignrp(5)
        , mdrpb(31)
        , shprp2(22)
        , shprp2(44)
        , shprp2(7)
        , ix()
        #y  
        , sy()
        , mdapr(22)
        , alignrp(2)
        , mdrprg(0)
        , mdrpmb(23)
        , shprp2(32)
        , mdrp0rg(8)
        , alignrp(5)
        , mdrprg(7)
        , mdrpmb(44)
        , shprp2(46)
        , ip_round(44,23,36)
        , alignrp(45)
        , mdrpmb(31)
        , shprp2(33)
        , f_ip([15])
        , iy()
        ),

    'uni0E40':      #SARA AA
        packline(""
        , srp0(26)
        , 'SROUND 70'
        , mdrp0rg(3)
        , 'RTG'
        , tstemw_1(5)
        , h_head_1(23,17,11)
        , ix()
        #y
        , sy()
        , mdapr(26)
        , mirprb('vheight',5)
        , mdrp0g(0)
        , v_head_1(14,20,8)
        , iy()
        ),

    'uni0E42':      #SARA O
        packline(""
        , srp0(60)
        , mdrprw(22)
        , 'SROUND 74'
        , mdrp0rg(3)
        , 'RTG'
        , tstemw_1(38)
        , h_head_1(56,50,44)
        , ip_round(59,3,10)
        , tstemwc_1(33)
        , ix()
        #y
        , sy() 
        , mdapr(13)
        , tstemt_mid_2(30)
        , mdrp0rg(35)
        , tstemt_mid_2(7)
        , mdapr(59)
        , mdrpg(0)
        , v_head_1(47,53,41)
        , iy()
        ),

    'uni0E43':      #SARA AI MAIMUAN
        packline(""
        , srp0(68)
        , 'SROUND 74'
        , mdrp0rg(3)
        , 'RTG'
        , tstemw_1(34)
        , h_head_1(52,46,40)
        , ip_round(67,3,23)
        , v_head_1(64,58,17)
        , ip_round(17,68,9)
        , tstemwc_1(29)
        , ix()
        #y
        , sy() 
        , mdapr(26)
        , tstemt_thin_2(12)
        , mdrp0mb(61)
        , mdapr(61)
        , headhole_2(55)
        , hsph_2(20)
        #
        , mdapr(67)
        , mdrp0g(0)
        , v_head_1(43,49,37)
        , iy()
        ),

    'uni0E44':      #SARA AI MAIMALAI
        packline(""
        , srp0(55)
        , 'SROUND 74'
        , mdrp0rg(3)
        , 'RTG'
        , tstemw_1(33)
        , h_head_1(51,45,39)
        , srp0(3)
        , mdrpg(18)
        , f_ip([9,28,22,15])
        , mdapr(18)
        , f_dstr(9,ds_tstemw)
        , f_dstr(22,ds_tstemw)
        , ix()
        #y
        , sy() 
        , mdapr(30)
        , tstemtc_2(6)
        , mdrp0rg(24)
        , tstemtc_2(12)
        #
        , mdapr(54)
        , mdrp0g(0)
        , v_head_1(42,48,36)
        , iy()
        ),

    'uni0E45':      #LAKKHANGYAO
        packline(""
        , srp0(16)
        , mdrp0rw(8)
        , mdrp0rg(15)
        , tstemw0_2(1)
        , ix()
        #y
        , sy()
        , mdapr(16)
        , mirpmrg('vheight_lu',1)
        , v_ko(0,[],12,5)
        , iy()
        , v_dry_end(9)
        ),

    'uni0E46':      #MAIYAMOK
        packline(""
        , h_main_2(40, 18,tstemwc_1,9, 1,tstemw_2,26)
        , mdrp0rg(30)
        , headstem_1(12)
        , headhole_2(36)
        , add_ip(18,26,[21,22,23,5,6,7])
        , ix()
        #y
        , sy()
        , mdapr(39)
        , mirprg('vheight_lu',1)
        , v_ko(0,[],(23,21),(5,7))
        , mdrp0mrg(22)
        , tstemt_2(6)
        , mdrp0rg(9)
        , v_head_2(33,27,15)
        , iy()
        ),

    'uni0E47':      #MAITAIKHU
        packline(""
        , srp0(65)
        , mdrp0mrw(49)
        , mdrpmrg(22)
        , mdrpb(55)
        , mdrp0rg(61)
        , mdrpb(43)
        , mdrp0rg(32)
        , f_ip([38,5])
        , mdrpb(11)
        , ix()
        #y
        , sy()
        , v_sara(8)
        , mdrpb(35)
        , mdrp0rg(38)
        , mdrpb(5)
        , srp0(8)
        , mdrp0g(0)
        , mdrpb(52)
        , mdrpb(43)
        , mdrp0rg(58)
        , mdrp0b(46)
        , mdrp0rw(29)
        , 'RUTG'
        , mdapr(29)
        , 'RTG'
        , mdrpb(14)
        , iy()
        ),

    'base.uni0E47.high':      #MAITAIKHU
        packline(""
        , mdapr(49)
        , mdrpmrg(22)
        , mdrpb(55)
        , mdrp0rg(61)
        , mdrpb(43)
        , mdrp0rg(32)
        , f_ip([38,5])
        , mdrpb(11)
        , ix()
        #y
        , sy()
        , mdapr(8)
        , mdrpb(35)
        , mdrp0rg(38)
        , mdrpb(5)
        , srp0(8)
        , mdrp0g(0)
        , mdrpb(52)
        , mdrpb(43)
        , mdrp0rg(58)
        , mdrp0b(46)
        , mdrp0rw(29)
        , 'RUTG'
        , mdapr(29)
        , 'RTG'
        , mdrpb(14)
        , iy()
        ),

    'uni0E48':      #MAI EK
        packline(""
        , srp0(4)
        , mdrp0mrw(0)
        , mdrpmb(1)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , mdrpmb(3)
        , iy()
        ),

    'base.uni0E48.low':      #MAI EK
        packline(""
        , srp0(4)
        , mdrp0mrw(0)
        , mdrpmb(1)
        , ix()
        #y
        , sy()
        , mdapr(4)
        , v_sara(0)
        , mdrpmb(3)
        , iy()
        ),

    'uni0E49':      #MAI THO
        packline(""
        , mdapr(17)
        , mdrpb(16)
        , mdrp0rg(10)
        , mdrpb(23)
        , mdrp0rg(29)
        , mdrpb(4)
        , mdrp0rg(0)
        , mdrpb(13)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , mdrpb(13)
        , mdrp0rg(1)
        , mdrpb(20)
        , mdrp0rg(26)
        , mdrpb(7)
        , mdrpmrg(17)
        , iy()
        ),

    'base.uni0E49.low':      #MAI THO
        packline(""
        , srp0(32)
        , mdrp0rw(17)
        , mdrpb(16)
        , mdrp0rg(10)
        , mdrpb(23)
        , mdrp0rg(29)
        , mdrpb(4)
        , mdrp0rg(0)
        , mdrpb(13)
        , ix()
        #y
        , sy()
        , mdapr(32)
        , v_sara(0)
        , mdrpb(13)
        , mdrp0rg(1)
        , mdrpb(20)
        , mdrp0rg(26)
        , mdrpb(7)
        , mdrpmrg(17)
        , iy()
        ),

    'uni0E4A':      #MAI TRI
        packline(""
                , srp0(48)
        , mdrp0mrw(27)
        , mdrpb(3)
        , mdrp0rg(33)
        , mdrpb(32)
        , srp0(27)
        , mdrp0rg(19)
        , mdrpb(10)
        , mdrpb(45)
        , mdrp0rg(39)
        , mdrpb(13)
        , add_ip(19,27,[22,23,24,6,7,8])
        , ix()
        #y
        , sy()
        , mdapr(48)
        , v_sara(0)
        , mdrpb(29)
        , mdrp0g(16)
        , mdrpb(36)
        , mdrp0rg(42)
        , mdapr(42)
        , mdrpb(10)
        , mdrp0rg(8)
        , alignrp(6)
        , mdrpb(22)
        , shprp2(24)
        , mdrpmb(32)
        , iy()
        ),

    'base.uni0E4A.low':      #MAI TRI
        packline(""
        , srp0(48)
        , mdrp0mrw(27)
        , mdrpb(3)
        , mdrp0rg(33)
        , mdrpb(32)
        , srp0(27)
        , mdrp0rg(19)
        , mdrpb(10)
        , mdrpb(45)
        , mdrp0rg(39)
        , mdrpb(13)
        , add_ip(19,27,[22,23,24,6,7,8])
        , ix()
        #y
        , sy()
        , mdapr(48)
        , v_sara(0)
        , mdrpb(29)
        , mdrp0g(16)
        , mdrpb(36)
        , mdrp0rg(42)
        , mdapr(42)
        , mdrpb(10)
        , mdrp0rg(8)
        , alignrp(6)
        , mdrpb(22)
        , shprp2(24)
        , mdrpmb(32)
        , iy()
        ),

    'uni0E4B':      #MAI CHATTAWA
        packline(""
        , mdapr(0)
        , alignrp(16)
        , mdrpmrg(22)
        , mdrp0b(2)
        , alignrp(14)
        , mdrpmrb(7)
        , ix()
        #y  
        , sy()
        , mdapr(0)
        , mdrp0mrg(23)
        , alignrp(6)
        , mdrp0b(20)
        , alignrp(9)
        , mdrpmrb(15)
        , iy()
        ),

    'base.uni0E4B.low':      #MAI CHATTAWA
        packline(""
        , srp0(28)
        , mdrp0mrw(0)
        , alignrp(16)
        , mdrprg(22)
        , mdrp0b(2)
        , alignrp(14)
        , mdrpmrg(7)
        , ix()
        #y  
        , sy() 
        , mdapr(28)
        , v_sara(0)
        , mdrp0mrg(23)
        , alignrp(6)
        , mdrp0b(20)
        , alignrp(9)
        , mdrpmb(15)
        , iy()
        ),

    'uni0E4C':      #THANTHAKHAT
        packline(""
        , mdapr(10)
        , mdrp0rg(3)
        , mdrpb(29)
        , mdrp0rg(23)
        , mdrpb(17)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , mdrpb(20)
        , mdrp0rg(26)
        , mdrp0rg(13)
        , mdrpb(6)
        , iy()
        ),

    'base.uni0E4C.low':      #THANTHAKHAT
        packline(""
        , srp0(32)
        , mdrp0mrw(17)
        , mdrprg(10)
        , mdrpb(23)
        , mdrp0rg(29)
        , mdrpb(3)
        , ix()
        #y
        , sy()
        , mdapr(32)
        , v_sara(0)
        , mdrpb(20)
        , mdrp0rg(26)
        , mdrp0rg(13)
        , mdrpb(6)
        , iy()
        ),

    'uni0E4D':      #NIKHAHIT
        packline(""
        , srp0(24)
        , mdrp0mrw(9)
        , mdrpb(15)
        , mdrp0rg(21)
        , mdrpb(3)
        , ix()
        #y
        , sy() 
        , v_sara(0)
        , mdrpb(12)
        , mdrp0rg(18)
        , mdrpb(6)
        , iy()
        ),  

    'base.uni0E4D.high':      #NIKHAHIT
        packline(""
        , mdapr(9)
        , mdrpb(15)
        , mdrp0rg(21)
        , mdrpb(3)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , mdrpb(12)
        , mdrp0rg(18)
        , mdrpb(6)
        , iy()
        ),

    'uni0E4E':      #YAMAKKAN
        packline(""
        , srp0(37)
        , mdrp0mrw(15)
        , mdrprg(25)
        , mdrprg(35)
        , mdrp0rg(20)
        , mdrpb(9)
        , mdrp0rg(29)
        , mdrpb(3)
        , ix()
        #y
        , sy()
        , v_sara(0)
        , mdrpb(32)
        , mdrp0rg(25)
        , mdrpb(24)
        , f_ip([6])
        , mdrp0rg(17)
        , mdrpb(12)
        , iy()
        ),

    'uni0E4F':      #FONGMAN
        packline(""
        , h_skel_2(37, 3,'',21, 15,'',9)
        , add_ip(21,15,[27,33])
        , ix()
        #y
        , sy()
        , mdapr(0)
        , mdrpmb(12)
        , mdapr(6)
        , mdrpmb(18)
        , add_ip(18,12,[30,24])
        , iy()
        ),  

    'uni0E50':      #THAI DIGIT ZERO
        packline(""
        , h_main_2(25, 3,tstemw_num_1,21, 15,tstemw_num_2,9)
        , ix()
        #y
        , sy()
        , mdapr(25)
        , mdrpg(0)
        , vt_num(6)
        , tstemt_num_2(18)
        , srp0(0)
        , tstemt_num_1(12)
        , iy()
        ),

    'uni0E51':      #THAI DIGIT ONE
        packline(""
        , h_main_2(52, 3,tstemwc_num_1,22, 16,tstemwc_num_2,9)
        , ip_round(22,16,33)
        , v_head_2(39,45,27)
        , srp0(9)
        , mdrprg(13)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , alignrp(13)
        , vt_num(6)
        , tstemt_num_2(19)
        , srp0(0)
        , mdrpg(12,ds_tstemt)
        , tstemt_num_1(25)
        , ip_round(19,0,30)
        , headstem_2(42)
        , hsph_2(36)
        , iy()
        ),

    'uni0E52':      #THAI DIGIT TWO
        packline(""
        , h_main_2(54, 1,tstemw_num_1,9, 14,tstemwc_num_2,38)
        , mdrprg(5)
        , ip_round(9,14,30)
        , mdrpb(21)
        , v_head_1(50,44,24)
        , add_ip(30,38,[33,34,35,17,18,19])
        , ix()
        #y
        , sy()
        , mdapr(0)
        , tstemt_num_1(11)
        , vt_num((35,33))
        , tstemt_num_2(17)
        , shprp2(19)
        , mdrp0mrg(34)
        , mdrpb(18)
        , ip_round(11,35,27)
        , headstem_1(41)
        , hsph0_1(47)
        , mdrpb(21)
        , mdapr(6)
        , mdrpb(5)
        , iy()
        ),

    'uni0E53':      #THAI DIGIT THREE
        packline(""
        , h_main_2(60, 32,tstemw_num_1,19, 4,tstemw_num_2,44)
        , ip_round(19,4,26)
        , headstem_2(50)
        , hsph_2(56)
#        , ip_round(19,4,12)
#        , mdrpb(10)
#        , f_ip([38])
, add_ip(19,4,[38])
, srp0(38)
, mdrpb(12)
, mdrpb(10)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , mdrpg(29)
        , vt_num(41)
        , alignrp(35)
        , tstemtc_num_2(7)
        , shprp2(16)
        , mdrprg(11)
        , f_ip([38])
        #
        , srp0(29)
        , v_head_1(47,53,23)
        , iy()
        ),

    'uni0E54':      #THAI DIGIT FOUR
        packline(""
        , srp0(61)
        , mdrp0mrw(47)
        , mdrprg(18)
        , 'SROUND 68'
        , ip_round(60,47,10)
        , 'RTG'
        , tstemwc_num_1(25)
        , ip_round(10,47,33)
        , v_head_1(57,51,39)
        , add_ip(33,39,[42,30])
        , ix()
        #y
        , sy()
        , mdapr(60)
        , mdrpg(0)
        , shprp2(7)
        , mdrp0rg(13)
        , tstemtc_num_2(21)
        , srp0(0)
        , tstemtc_num_1(47)
        , shprp2(28)
        , ip_round(21,28,31)
        , v_head_1(48,54,36)
        , add_ip(48,28,[31,42])
        , iy()
        ),

    'uni0E55':      #THAI DIGIT FIVE
        packline(""
        , srp0(82)
        , mdrp0mrw(56)
        , mdrprg(27)
        , 'SROUND 68'
        , ip_round(81,56,10)
        , 'RTG'
        , tstemwc_num_1(34)
        , ip_round(10,56,42)
        , v_head_1(66,60,48)
        , add_ip(42,48,[51,39])
        , ip_round(10,27,15)
        , v_head_1(78,72,21)
        , ix()
        #y
        , sy()
        , mdapr(81)
        , mdrpg(0)
        , shprp2(7)
        , mdrp0rg(69)
        , mdrpg(23)
        , mdrpg(13)
        , tstemtc_num_2(30)
        , srp0(0)
        , tstemtc_num_1(56)
        , shprp2(37)
        , ip_round(30,37,40)
        , v_head_1(57,63,45)
        , add_ip(57,37,[51,40])
        , srp0(69)
        , hsph0_1(18)
        , headstem_2(75)
        , iy()
        ),

    'uni0E56':      #THAI DIGIT SIX
        packline(""
#        , srp0(51)
#        , mdrp0mrw(35)
#        , tstemwc_num_2(16)
#        , 'SROUND 68'
#        , mdrp0rg(3)
#        , 'RTG'
#        , alignrp(22)
#        , mdrpb(29)
#        , mdrprg(25)
, h_main_01(51, 25, 16,tstemwc_num_2,35)
, mdrp0rg(3)
, alignrp(22)
, mdrpb(29)
        , v_head_1(47,41,9)
        , ix()
, srp0(2)
, mdrpg(1)
        #y
        , sy()
        , mdapr(50)
        , mdrpg(0)
        , vt_num(32)
        , tstemtc_num_2(19)
        , mdrpmrg(22,"9+8 ")
        , f_ip([29])
        , mdrp0rg(26)
        , mdrpb(25,ds_tstemtc_num,direction="-")
        , srp0(0)
        , tstemtc_num_1(13)
        , 'RDTG'
        , ip_round(32,50,6)
        , 'RTG'
        , headstem_2(44)
        , hsph0_2(38)
        , mdrpb(2)
        , iy()
        ),

    'uni0E57':      #THAI DIGIT SEVEN
        packline(""
        , h_main_2(72, 28,tstemwc_num_1,17, 47,tstemw_num_2,55)
        , mdrp0rg(62)
        , headhole_2(68)
        , headstem_1(22)
        , srp0(47)
        , mdrp0mrw(40)
        , mdapr(40)
        , tstemwc_num_2(4)
        , add_ip(17,4,[34])
        , srp0(34)
        , mdrpb(11)
        , mdrpb(10)
        , srp0(55)
        , mdrprg(52)
        , ix()
        , srp0(68)
        , mdrpb(26)
        #y
        , sy()
        , mdapr(0)
        , tstemt_num_1(43)
        , mdrpg(25)
        , vt_num(37)
        , alignrp(31)
        , tstemtc_num_2(7)
        , shprp2(14)
        , mdrp0rg(53)
        , mdrpmb(54,ds_tstemt,direction='-')
        , srp0(25)
        , v_head_1(59,65,19)
        , ip_round(7,19,10)
        , add_ip(10,37,[34])
        , iy()
        ),

    'uni0E58':      #THAI DIGIT EIGHT
        packline(""
        , h_main_10(62, 11,tstemwc_num_1,26, 46)
        , mdrp0rg(29)
        , tstemw_num_1(8)
        , srp0(46)
        , mdrprg(19)
        , v_head_2(52,58,40)
        , add_ip(29,46,[33,35,36,0,2,3])
        , ix()
        #y
        , sy()
        , mdapr(61)
        , mdrpg(0)
        , shprp2(8)
        , t0_vheight_num(15)
        , tstemt_num_2(22)
        , srp0(0)
        , tstemtc_num0_1(29)
        , mdrpg(38)
        , srp0(61)
        , mdrp0rg(43)
        , headstem_2(55)
        , hsph_2(49)
        , srp0(61)
        , mdrp0rg(33)
        , tstemt_num_2(5)
        , add_ip(33,0,[35,36,2,3])
        , iy()
        ),

    'uni0E59':      #THAI DIGIT NINE
        packline(""
        , srp0(62)
        , mdrp0mrw(40)
        , mdrprg(37)
        , mdrpmb(41)
        , f_ip([33])
        , 'SROUND 68'
        , ip_round(61,40,21)
        , 'RTG'
        , tstemwc_num_1(8)
        , 'SROUND 71'
        , mdrp0rg(52)
        , 'RTG'
        , headhole_2(58)
        , headstem_1(15)
        , ip_round(8,40,46)
#        , mdrp0mrb(2)
#        , alignrp(27)
#        , tstemw_num_1(48)
#        , mdrp0g(1)
#        , tstemw_num_1(0)
, mdrp0g(48)
, tstemw_num_2(2)
, mdrp0g(0)
, tstemw_num_2(1)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , mdrpg(18)
        , vt_num(30)
        , alignrp(24)
        , tstemtc_num_2(44)
        , shprp2(5)
        , f_ip([27,33])
        , mdrprg(41)
        , mdrp0rg(36)
        , mdrpmb(37,ds_tstemt,direction="-")
        , srp0(18)
        , v_head_1(49,55,12)
        , iy()
        ),

    'uni0E5A':      #ANGKHANKHU
        packline(""
        , srp0(45)
        , mdrp0mrw(43)
        , tstemw0_2(41)
        , mdrp0mrw(0)
        , mdapr(0)
        , tstemw0_2(3)
        , alignrp(26)
        , h_serif(1)
        , ip_round(44,3,12)
        , v_head_1(37,31,18)
        , ix()
        #y
        , sy() 
        , mdapr(0)
        , alignrp(40)
        , tstemt_1(3)
        , t0_vheight(27)
        , alignrp(15)
        , alignrp(43)
        , mdrpmb(6,ds_tstemt,direction="-")
        , headstem_2(34)
        , hsph_2(28)
        , mdrp0rg(23)
        , tstemtc_2(9)
        , iy()
        ),

    'uni0E5B':      #KHOMUT
        packline(""
        , srp0(78)
        , mdrprw(48)
        , 'SROUND 68'
        , ip_round(77,48,3)
        , 'RTG'
        , tstemwc_num_1(20)
        , 'RDTG'
        , mdrp0rg(15)
        , 'RTG'
        , v_head_1(74,68,9)
        , srp0(3)
        , 'RDTG'
        , mdrp0rg(26)
        , 'RTG'
        , mdrpb(27)
        , f_ip([62])
        , mdrp0rg(33)
        , mdrpb(34)
        , f_ip([56])
        , mdrp0rg(40)
        , mdrpb(41)
        , f_ip([50])
        , ix()
        #y
        , sy()
        , mdapr(77)
        , mdrpg(0)
        , t0_vheight_num(6)
        , tstemtc_num_2(17)
        , 'RDTG'
        , mdrp0rg(65)
        , 'RTG'
        , headhole_1(71)
        , headstem_2(12)
        , srp0(0)
        , tstemtc_num_1(23)
        , ip_round(6,0,26)
        , alignrp(33)
        , alignrp(40)
        , mdrp0mrw(44)
        , tstemt_num_2(47)
        , ip_round(27,0,59)
        , alignrp(53)
        , add_ip(27,59,[62,56,50])
        , iy()
        ),

}

### THESE LINES IN THE BOTTOM
self_func = []
for i in dir():
    if callable(eval(i)): self_func.append(i)

for i in pseudo_code_dict.keys():
    p_list = pseudo_code_dict[i].split('\n')
    for j in range(len(p_list)):
        if '(' in p_list[j]:
            if p_list[j].split('(',1)[0] in self_func:
                l = [n for n in range(len(p_list[j])) if p_list[j][n] == ')']
                t = p_list[j][:l[-1]+1]
                p_list[j] = p_list[j].rep_listace(t, eval(t))
    pseudo_code_dict[i] = '\n'.join(p_list)


